/* LayoutsManager.c generated by valac 0.56.17, the Vala compiler
 * generated from LayoutsManager.vala, do not modify */

/*-
 * Copyright (c) 2015 Wingpanel Developers (http://launchpad.net/wingpanel)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "keyboard.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <ibus.h>
#include <gtk/gtk.h>
#include <granite.h>
#include <libxml/tree.h>
#include <libxml/parser.h>
#include <libxml/xpath.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	KEYBOARD_WIDGETS_LAYOUT_MANAGER_0_PROPERTY,
	KEYBOARD_WIDGETS_LAYOUT_MANAGER_CURRENT_LANGUAGE_CODE_PROPERTY,
	KEYBOARD_WIDGETS_LAYOUT_MANAGER_CURRENT_LAYOUT_VARIANT_PROPERTY,
	KEYBOARD_WIDGETS_LAYOUT_MANAGER_NUM_PROPERTIES
};
static GParamSpec* keyboard_widgets_layout_manager_properties[KEYBOARD_WIDGETS_LAYOUT_MANAGER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
#define _xmlFreeDoc0(var) ((var == NULL) ? NULL : (var = (xmlFreeDoc (var), NULL)))
#define _xmlXPathFreeContext0(var) ((var == NULL) ? NULL : (var = (xmlXPathFreeContext (var), NULL)))
#define _xmlXPathFreeObject0(var) ((var == NULL) ? NULL : (var = (xmlXPathFreeObject (var), NULL)))
typedef struct _Block1Data Block1Data;
typedef struct _Block2Data Block2Data;
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
enum  {
	KEYBOARD_WIDGETS_LAYOUT_MANAGER_UPDATED_SIGNAL,
	KEYBOARD_WIDGETS_LAYOUT_MANAGER_NUM_SIGNALS
};
static guint keyboard_widgets_layout_manager_signals[KEYBOARD_WIDGETS_LAYOUT_MANAGER_NUM_SIGNALS] = {0};

struct _KeyboardWidgetsLayoutManagerPrivate {
	gchar* _current_language_code;
	gchar* _current_layout_variant;
	GSettings* settings;
	GList* engines;
	GtkBox* xkb_box;
	GtkBox* ibus_box;
	GtkRevealer* ibus_box_revealer;
	GtkRevealer* ibus_header_revealer;
	GraniteSwitchModelButton* ibus_header;
	IBusBus* bus;
	GSimpleActionGroup* actions;
};

struct _Block1Data {
	int _ref_count_;
	KeyboardWidgetsLayoutManager* self;
	gchar* xkb_label;
	gchar* ibus_label;
};

struct _Block2Data {
	int _ref_count_;
	KeyboardWidgetsLayoutManager* self;
	KeyboardWidgetsLayoutButton* previously_active_button;
	gboolean found;
	guint index;
};

static gint KeyboardWidgetsLayoutManager_private_offset;
static gpointer keyboard_widgets_layout_manager_parent_class = NULL;

static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void keyboard_widgets_layout_manager_populate_layouts (KeyboardWidgetsLayoutManager* self);
static void __lambda4_ (KeyboardWidgetsLayoutManager* self,
                 GtkWidget* child);
static void ___lambda4__gfunc (gconstpointer data,
                        gpointer self);
static void __lambda5_ (KeyboardWidgetsLayoutManager* self,
                 GtkWidget* child);
static void ___lambda5__gfunc (gconstpointer data,
                        gpointer self);
static void keyboard_widgets_layout_manager_set_ibus_engine (KeyboardWidgetsLayoutManager* self,
                                                      const gchar* manager,
                                                      const gchar* source);
static void keyboard_widgets_layout_manager_set_active_layout_from_settings (KeyboardWidgetsLayoutManager* self);
static void keyboard_widgets_layout_manager_action_change_layout (KeyboardWidgetsLayoutManager* self,
                                                           GSimpleAction* action,
                                                           GVariant* parameter);
static void keyboard_widgets_layout_manager_set_active_layout (KeyboardWidgetsLayoutManager* self,
                                                        guint32 index);
static GVariant* _variant_new1 (guint32 value);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda8_ (Block1Data* _data1_,
                 GtkWidget* child);
static void ___lambda8__gfunc (gconstpointer data,
                        gpointer self);
static void __lambda9_ (Block1Data* _data1_,
                 GtkWidget* child);
static void ___lambda9__gfunc (gconstpointer data,
                        gpointer self);
static GVariant* _variant_new2 (guint32 value);
static void keyboard_widgets_layout_manager_set_active_layout_to_xkb (KeyboardWidgetsLayoutManager* self);
static GVariant* _variant_new3 (guint32 value);
static void keyboard_widgets_layout_manager_set_layout_active_in_box (KeyboardWidgetsLayoutManager* self,
                                                               GtkBox* layout_box,
                                                               guint index,
                                                               gboolean clear);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda6_ (Block2Data* _data2_,
                 GtkWidget* widget);
static void ___lambda6__gfunc (gconstpointer data,
                        gpointer self);
static void ____lambda7_ (KeyboardWidgetsLayoutManager* self,
                   GtkWidget* widget);
static void _____lambda7__gfunc (gconstpointer data,
                          gpointer self);
static GObject * keyboard_widgets_layout_manager_constructor (GType type,
                                                       guint n_construct_properties,
                                                       GObjectConstructParam * construct_properties);
static void _keyboard_widgets_layout_manager___lambda10_ (KeyboardWidgetsLayoutManager* self);
static void __keyboard_widgets_layout_manager___lambda10__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                              gpointer self);
static void _keyboard_widgets_layout_manager___lambda11_ (KeyboardWidgetsLayoutManager* self);
static void __keyboard_widgets_layout_manager___lambda11__g_settings_changed (GSettings* _sender,
                                                                       const gchar* key,
                                                                       gpointer self);
static void _keyboard_widgets_layout_manager___lambda12_ (KeyboardWidgetsLayoutManager* self);
static void __keyboard_widgets_layout_manager___lambda12__ibus_bus_connected (IBusBus* _sender,
                                                                       gpointer self);
static void _keyboard_widgets_layout_manager___lambda13_ (KeyboardWidgetsLayoutManager* self);
static void __keyboard_widgets_layout_manager___lambda13__ibus_bus_disconnected (IBusBus* _sender,
                                                                          gpointer self);
static void _keyboard_widgets_layout_manager___lambda14_ (KeyboardWidgetsLayoutManager* self);
static void __keyboard_widgets_layout_manager___lambda14__g_settings_changed (GSettings* _sender,
                                                                       const gchar* key,
                                                                       gpointer self);
static void _keyboard_widgets_layout_manager_action_change_layout_g_simple_action_activate (GSimpleAction* _sender,
                                                                                     GVariant* parameter,
                                                                                     gpointer self);
static void keyboard_widgets_layout_manager_finalize (GObject * obj);
static GType keyboard_widgets_layout_manager_get_type_once (void);
static void _vala_keyboard_widgets_layout_manager_get_property (GObject * object,
                                                         guint property_id,
                                                         GValue * value,
                                                         GParamSpec * pspec);
static void _vala_keyboard_widgets_layout_manager_set_property (GObject * object,
                                                         guint property_id,
                                                         const GValue * value,
                                                         GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
keyboard_widgets_layout_manager_get_instance_private (KeyboardWidgetsLayoutManager* self)
{
	return G_STRUCT_MEMBER_P (self, KeyboardWidgetsLayoutManager_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 31 "../src/LayoutsManager.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 201 "LayoutsManager.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 31 "../src/LayoutsManager.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 209 "LayoutsManager.c"
}

static void
__lambda4_ (KeyboardWidgetsLayoutManager* self,
            GtkWidget* child)
{
#line 134 "../src/LayoutsManager.vala"
	g_return_if_fail (child != NULL);
#line 135 "../src/LayoutsManager.vala"
	gtk_widget_destroy (child);
#line 220 "LayoutsManager.c"
}

static void
___lambda4__gfunc (gconstpointer data,
                   gpointer self)
{
#line 134 "../src/LayoutsManager.vala"
	__lambda4_ ((KeyboardWidgetsLayoutManager*) self, (GtkWidget*) data);
#line 229 "LayoutsManager.c"
}

static void
__lambda5_ (KeyboardWidgetsLayoutManager* self,
            GtkWidget* child)
{
#line 138 "../src/LayoutsManager.vala"
	g_return_if_fail (child != NULL);
#line 139 "../src/LayoutsManager.vala"
	gtk_widget_destroy (child);
#line 240 "LayoutsManager.c"
}

static void
___lambda5__gfunc (gconstpointer data,
                   gpointer self)
{
#line 138 "../src/LayoutsManager.vala"
	__lambda5_ ((KeyboardWidgetsLayoutManager*) self, (GtkWidget*) data);
#line 249 "LayoutsManager.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 268 "LayoutsManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 180 "../src/LayoutsManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 276 "LayoutsManager.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 298 "LayoutsManager.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 302 "LayoutsManager.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 308 "LayoutsManager.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 312 "LayoutsManager.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 316 "LayoutsManager.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 324 "LayoutsManager.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 352 "LayoutsManager.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 361 "LayoutsManager.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 375 "LayoutsManager.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 384 "LayoutsManager.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 398 "LayoutsManager.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 407 "LayoutsManager.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 416 "LayoutsManager.c"
}

static void
keyboard_widgets_layout_manager_populate_layouts (KeyboardWidgetsLayoutManager* self)
{
	GtkBox* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GtkBox* _tmp3_;
	GList* _tmp4_;
	GList* _tmp5_;
	GtkRevealer* _tmp6_;
	GtkRevealer* _tmp7_;
	GVariant* source_list = NULL;
	GSettings* _tmp8_;
	GVariant* _tmp9_;
	IBusBus* _tmp10_;
	KeyboardWidgetsLayoutButton* layout_button = NULL;
	GVariantIter* iter = NULL;
	GVariant* _tmp13_;
	GVariantIter* _tmp14_;
	guint32 i = 0U;
	gchar* manager_type = NULL;
	gchar* source = NULL;
	GtkBox* _tmp97_;
	GList* _tmp98_;
	GList* _tmp99_;
	gboolean _tmp100_;
#line 133 "../src/LayoutsManager.vala"
	g_return_if_fail (self != NULL);
#line 134 "../src/LayoutsManager.vala"
	_tmp0_ = self->priv->xkb_box;
#line 134 "../src/LayoutsManager.vala"
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
#line 134 "../src/LayoutsManager.vala"
	_tmp2_ = _tmp1_;
#line 134 "../src/LayoutsManager.vala"
	g_list_foreach (_tmp2_, ___lambda4__gfunc, self);
#line 134 "../src/LayoutsManager.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_list_free (_tmp2_), NULL));
#line 138 "../src/LayoutsManager.vala"
	_tmp3_ = self->priv->ibus_box;
#line 138 "../src/LayoutsManager.vala"
	_tmp4_ = gtk_container_get_children ((GtkContainer*) _tmp3_);
#line 138 "../src/LayoutsManager.vala"
	_tmp5_ = _tmp4_;
#line 138 "../src/LayoutsManager.vala"
	g_list_foreach (_tmp5_, ___lambda5__gfunc, self);
#line 138 "../src/LayoutsManager.vala"
	(_tmp5_ == NULL) ? NULL : (_tmp5_ = (g_list_free (_tmp5_), NULL));
#line 142 "../src/LayoutsManager.vala"
	_tmp6_ = self->priv->ibus_header_revealer;
#line 142 "../src/LayoutsManager.vala"
	gtk_revealer_set_reveal_child (_tmp6_, FALSE);
#line 143 "../src/LayoutsManager.vala"
	_tmp7_ = self->priv->ibus_box_revealer;
#line 143 "../src/LayoutsManager.vala"
	gtk_revealer_set_reveal_child (_tmp7_, FALSE);
#line 145 "../src/LayoutsManager.vala"
	_tmp8_ = self->priv->settings;
#line 145 "../src/LayoutsManager.vala"
	_tmp9_ = g_settings_get_value (_tmp8_, "sources");
#line 145 "../src/LayoutsManager.vala"
	source_list = _tmp9_;
#line 146 "../src/LayoutsManager.vala"
	(self->priv->engines == NULL) ? NULL : (self->priv->engines = (_g_list_free__g_object_unref0_ (self->priv->engines), NULL));
#line 146 "../src/LayoutsManager.vala"
	self->priv->engines = NULL;
#line 147 "../src/LayoutsManager.vala"
	_tmp10_ = self->priv->bus;
#line 147 "../src/LayoutsManager.vala"
	if (ibus_bus_is_connected (_tmp10_)) {
#line 489 "LayoutsManager.c"
		IBusBus* _tmp11_;
		GList* _tmp12_;
#line 148 "../src/LayoutsManager.vala"
		_tmp11_ = self->priv->bus;
#line 148 "../src/LayoutsManager.vala"
		_tmp12_ = ibus_bus_list_engines (_tmp11_);
#line 148 "../src/LayoutsManager.vala"
		(self->priv->engines == NULL) ? NULL : (self->priv->engines = (_g_list_free__g_object_unref0_ (self->priv->engines), NULL));
#line 148 "../src/LayoutsManager.vala"
		self->priv->engines = _tmp12_;
#line 149 "../src/LayoutsManager.vala"
		keyboard_widgets_layout_manager_set_ibus_engine (self, KEYBOARD_WIDGETS_LAYOUT_MANAGER_XKB_MANAGER_TYPE, "");
#line 502 "LayoutsManager.c"
	}
#line 152 "../src/LayoutsManager.vala"
	layout_button = NULL;
#line 153 "../src/LayoutsManager.vala"
	_tmp13_ = source_list;
#line 153 "../src/LayoutsManager.vala"
	_tmp14_ = g_variant_iter_new (_tmp13_);
#line 153 "../src/LayoutsManager.vala"
	iter = _tmp14_;
#line 154 "../src/LayoutsManager.vala"
	i = (guint32) 0;
#line 157 "../src/LayoutsManager.vala"
	while (TRUE) {
#line 516 "LayoutsManager.c"
		GVariantIter* _tmp15_;
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
		gboolean _tmp18_;
		gchar* language = NULL;
		gchar* _tmp19_;
		gchar* layout_variant = NULL;
		gchar* button_label = NULL;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		GQuark _tmp23_ = 0U;
#line 162 "../src/LayoutsManager.vala"
		static GQuark _tmp22_label0 = 0;
#line 162 "../src/LayoutsManager.vala"
		static GQuark _tmp22_label1 = 0;
#line 532 "LayoutsManager.c"
		const gchar* _tmp66_ = NULL;
		const gchar* _tmp67_;
		gchar* _tmp68_;
		const gchar* _tmp69_;
		GVariant* action_target = NULL;
		GVariant* _tmp77_;
		const gchar* _tmp78_ = NULL;
		const gchar* _tmp79_;
		const gchar* _tmp80_;
		gchar* _tmp81_;
		gchar* _tmp82_;
		const gchar* _tmp83_;
		const gchar* _tmp84_;
		const gchar* _tmp85_;
		GVariant* _tmp86_;
		KeyboardWidgetsLayoutButton* _tmp87_;
		const gchar* _tmp88_;
		const gchar* _tmp89_;
		GQuark _tmp91_ = 0U;
#line 229 "../src/LayoutsManager.vala"
		static GQuark _tmp90_label0 = 0;
#line 229 "../src/LayoutsManager.vala"
		static GQuark _tmp90_label1 = 0;
#line 556 "LayoutsManager.c"
		guint32 _tmp96_;
#line 157 "../src/LayoutsManager.vala"
		_tmp15_ = iter;
#line 157 "../src/LayoutsManager.vala"
		_tmp18_ = g_variant_iter_next (_tmp15_, "(ss)", &_tmp16_, &_tmp17_, NULL);
#line 157 "../src/LayoutsManager.vala"
		_g_free0 (manager_type);
#line 157 "../src/LayoutsManager.vala"
		manager_type = _tmp16_;
#line 157 "../src/LayoutsManager.vala"
		_g_free0 (source);
#line 157 "../src/LayoutsManager.vala"
		source = _tmp17_;
#line 157 "../src/LayoutsManager.vala"
		if (!_tmp18_) {
#line 157 "../src/LayoutsManager.vala"
			break;
#line 574 "LayoutsManager.c"
		}
#line 158 "../src/LayoutsManager.vala"
		_tmp19_ = g_strdup ("us");
#line 158 "../src/LayoutsManager.vala"
		language = _tmp19_;
#line 159 "../src/LayoutsManager.vala"
		layout_variant = NULL;
#line 160 "../src/LayoutsManager.vala"
		button_label = NULL;
#line 162 "../src/LayoutsManager.vala"
		_tmp20_ = manager_type;
#line 162 "../src/LayoutsManager.vala"
		_tmp21_ = _tmp20_;
#line 162 "../src/LayoutsManager.vala"
		_tmp23_ = (NULL == _tmp21_) ? 0 : g_quark_from_string (_tmp21_);
#line 162 "../src/LayoutsManager.vala"
		if (_tmp23_ == ((0 != _tmp22_label0) ? _tmp22_label0 : (_tmp22_label0 = g_quark_from_static_string (KEYBOARD_WIDGETS_LAYOUT_MANAGER_XKB_MANAGER_TYPE)))) {
#line 162 "../src/LayoutsManager.vala"
			switch (0) {
#line 594 "LayoutsManager.c"
				default:
				{
					const gchar* _tmp24_;
					const gchar* _tmp36_;
					const gchar* _tmp37_;
					gchar* _tmp38_;
#line 164 "../src/LayoutsManager.vala"
					_tmp24_ = source;
#line 164 "../src/LayoutsManager.vala"
					if (string_contains (_tmp24_, "+")) {
#line 605 "LayoutsManager.c"
						gchar** layouts = NULL;
						const gchar* _tmp25_;
						gchar** _tmp26_;
						gchar** _tmp27_;
						gint layouts_length1;
						gint _layouts_size_;
						gchar** _tmp28_;
						gint _tmp28__length1;
						const gchar* _tmp29_;
						gchar* _tmp30_;
						gchar** _tmp31_;
						gint _tmp31__length1;
						const gchar* _tmp32_;
						gchar* _tmp33_;
#line 165 "../src/LayoutsManager.vala"
						_tmp25_ = source;
#line 165 "../src/LayoutsManager.vala"
						_tmp27_ = _tmp26_ = g_strsplit (_tmp25_, "+", 2);
#line 165 "../src/LayoutsManager.vala"
						layouts = _tmp27_;
#line 165 "../src/LayoutsManager.vala"
						layouts_length1 = _vala_array_length (_tmp26_);
#line 165 "../src/LayoutsManager.vala"
						_layouts_size_ = layouts_length1;
#line 166 "../src/LayoutsManager.vala"
						_tmp28_ = layouts;
#line 166 "../src/LayoutsManager.vala"
						_tmp28__length1 = layouts_length1;
#line 166 "../src/LayoutsManager.vala"
						_tmp29_ = _tmp28_[0];
#line 166 "../src/LayoutsManager.vala"
						_tmp30_ = g_strdup (_tmp29_);
#line 166 "../src/LayoutsManager.vala"
						_g_free0 (language);
#line 166 "../src/LayoutsManager.vala"
						language = _tmp30_;
#line 167 "../src/LayoutsManager.vala"
						_tmp31_ = layouts;
#line 167 "../src/LayoutsManager.vala"
						_tmp31__length1 = layouts_length1;
#line 167 "../src/LayoutsManager.vala"
						_tmp32_ = _tmp31_[1];
#line 167 "../src/LayoutsManager.vala"
						_tmp33_ = g_strdup (_tmp32_);
#line 167 "../src/LayoutsManager.vala"
						_g_free0 (layout_variant);
#line 167 "../src/LayoutsManager.vala"
						layout_variant = _tmp33_;
#line 164 "../src/LayoutsManager.vala"
						layouts = (_vala_array_free (layouts, layouts_length1, (GDestroyNotify) g_free), NULL);
#line 656 "LayoutsManager.c"
					} else {
						const gchar* _tmp34_;
						gchar* _tmp35_;
#line 169 "../src/LayoutsManager.vala"
						_tmp34_ = source;
#line 169 "../src/LayoutsManager.vala"
						_tmp35_ = g_strdup (_tmp34_);
#line 169 "../src/LayoutsManager.vala"
						_g_free0 (language);
#line 169 "../src/LayoutsManager.vala"
						language = _tmp35_;
#line 668 "LayoutsManager.c"
					}
#line 173 "../src/LayoutsManager.vala"
					_tmp36_ = language;
#line 173 "../src/LayoutsManager.vala"
					_tmp37_ = layout_variant;
#line 173 "../src/LayoutsManager.vala"
					_tmp38_ = keyboard_widgets_layout_manager_get_name_for_xkb_layout (self, _tmp36_, _tmp37_);
#line 173 "../src/LayoutsManager.vala"
					_g_free0 (button_label);
#line 173 "../src/LayoutsManager.vala"
					button_label = _tmp38_;
#line 174 "../src/LayoutsManager.vala"
					break;
#line 682 "LayoutsManager.c"
				}
			}
		} else if (_tmp23_ == ((0 != _tmp22_label1) ? _tmp22_label1 : (_tmp22_label1 = g_quark_from_static_string (KEYBOARD_WIDGETS_LAYOUT_MANAGER_IBUS_MANAGER_TYPE)))) {
#line 162 "../src/LayoutsManager.vala"
			switch (0) {
#line 688 "LayoutsManager.c"
				default:
				{
					GList* _tmp39_;
					GList* _tmp40_;
#line 176 "../src/LayoutsManager.vala"
					_tmp39_ = self->priv->engines;
#line 176 "../src/LayoutsManager.vala"
					if (_tmp39_ == NULL) {
#line 177 "../src/LayoutsManager.vala"
						_g_free0 (button_label);
#line 177 "../src/LayoutsManager.vala"
						_g_free0 (layout_variant);
#line 177 "../src/LayoutsManager.vala"
						_g_free0 (language);
#line 177 "../src/LayoutsManager.vala"
						continue;
#line 705 "LayoutsManager.c"
					}
#line 180 "../src/LayoutsManager.vala"
					_tmp40_ = self->priv->engines;
#line 709 "LayoutsManager.c"
					{
						GList* engine_collection = NULL;
						GList* engine_it = NULL;
#line 180 "../src/LayoutsManager.vala"
						engine_collection = _tmp40_;
#line 180 "../src/LayoutsManager.vala"
						for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
#line 717 "LayoutsManager.c"
							IBusEngineDesc* _tmp41_;
							IBusEngineDesc* engine = NULL;
#line 180 "../src/LayoutsManager.vala"
							_tmp41_ = _g_object_ref0 ((IBusEngineDesc*) engine_it->data);
#line 180 "../src/LayoutsManager.vala"
							engine = _tmp41_;
#line 724 "LayoutsManager.c"
							{
								gboolean _tmp42_ = FALSE;
								IBusEngineDesc* _tmp43_;
#line 181 "../src/LayoutsManager.vala"
								_tmp43_ = engine;
#line 181 "../src/LayoutsManager.vala"
								if (_tmp43_ != NULL) {
#line 732 "LayoutsManager.c"
									IBusEngineDesc* _tmp44_;
									const gchar* _tmp45_;
									const gchar* _tmp46_;
									const gchar* _tmp47_;
#line 181 "../src/LayoutsManager.vala"
									_tmp44_ = engine;
#line 181 "../src/LayoutsManager.vala"
									_tmp45_ = ibus_engine_desc_get_name (_tmp44_);
#line 181 "../src/LayoutsManager.vala"
									_tmp46_ = _tmp45_;
#line 181 "../src/LayoutsManager.vala"
									_tmp47_ = source;
#line 181 "../src/LayoutsManager.vala"
									_tmp42_ = g_strcmp0 (_tmp46_, _tmp47_) == 0;
#line 747 "LayoutsManager.c"
								} else {
#line 181 "../src/LayoutsManager.vala"
									_tmp42_ = FALSE;
#line 751 "LayoutsManager.c"
								}
#line 181 "../src/LayoutsManager.vala"
								if (_tmp42_) {
#line 755 "LayoutsManager.c"
									const gchar* _tmp48_;
									IBusEngineDesc* _tmp59_;
									const gchar* _tmp60_;
									gchar* _tmp61_;
									IBusEngineDesc* _tmp62_;
									const gchar* _tmp63_;
									gchar* _tmp64_;
#line 182 "../src/LayoutsManager.vala"
									_tmp48_ = source;
#line 182 "../src/LayoutsManager.vala"
									if (string_contains (_tmp48_, "xkb")) {
#line 767 "LayoutsManager.c"
										IBusEngineDesc* _tmp49_;
										const gchar* _tmp50_;
										gchar* _tmp51_;
#line 183 "../src/LayoutsManager.vala"
										_tmp49_ = engine;
#line 183 "../src/LayoutsManager.vala"
										_tmp50_ = ibus_engine_desc_get_longname (_tmp49_);
#line 183 "../src/LayoutsManager.vala"
										_tmp51_ = g_strdup (_tmp50_);
#line 183 "../src/LayoutsManager.vala"
										_g_free0 (button_label);
#line 183 "../src/LayoutsManager.vala"
										button_label = _tmp51_;
#line 781 "LayoutsManager.c"
									} else {
										gchar* lang_name = NULL;
										IBusEngineDesc* _tmp52_;
										const gchar* _tmp53_;
										gchar* _tmp54_;
										const gchar* _tmp55_;
										IBusEngineDesc* _tmp56_;
										const gchar* _tmp57_;
										gchar* _tmp58_;
#line 185 "../src/LayoutsManager.vala"
										_tmp52_ = engine;
#line 185 "../src/LayoutsManager.vala"
										_tmp53_ = ibus_engine_desc_get_language (_tmp52_);
#line 185 "../src/LayoutsManager.vala"
										_tmp54_ = ibus_get_language_name (_tmp53_);
#line 185 "../src/LayoutsManager.vala"
										lang_name = _tmp54_;
#line 186 "../src/LayoutsManager.vala"
										_tmp55_ = lang_name;
#line 186 "../src/LayoutsManager.vala"
										_tmp56_ = engine;
#line 186 "../src/LayoutsManager.vala"
										_tmp57_ = ibus_engine_desc_get_longname (_tmp56_);
#line 186 "../src/LayoutsManager.vala"
										_tmp58_ = g_strdup_printf ("%s (%s)", _tmp55_, _tmp57_);
#line 186 "../src/LayoutsManager.vala"
										_g_free0 (button_label);
#line 186 "../src/LayoutsManager.vala"
										button_label = _tmp58_;
#line 182 "../src/LayoutsManager.vala"
										_g_free0 (lang_name);
#line 813 "LayoutsManager.c"
									}
#line 189 "../src/LayoutsManager.vala"
									_tmp59_ = engine;
#line 189 "../src/LayoutsManager.vala"
									_tmp60_ = ibus_engine_desc_get_language (_tmp59_);
#line 189 "../src/LayoutsManager.vala"
									_tmp61_ = g_strdup (_tmp60_);
#line 189 "../src/LayoutsManager.vala"
									_g_free0 (language);
#line 189 "../src/LayoutsManager.vala"
									language = _tmp61_;
#line 190 "../src/LayoutsManager.vala"
									_tmp62_ = engine;
#line 190 "../src/LayoutsManager.vala"
									_tmp63_ = ibus_engine_desc_get_layout_variant (_tmp62_);
#line 190 "../src/LayoutsManager.vala"
									_tmp64_ = g_strdup (_tmp63_);
#line 190 "../src/LayoutsManager.vala"
									_g_free0 (layout_variant);
#line 190 "../src/LayoutsManager.vala"
									layout_variant = _tmp64_;
#line 835 "LayoutsManager.c"
								}
#line 180 "../src/LayoutsManager.vala"
								_g_object_unref0 (engine);
#line 839 "LayoutsManager.c"
							}
						}
					}
#line 194 "../src/LayoutsManager.vala"
					break;
#line 845 "LayoutsManager.c"
				}
			}
		} else {
#line 162 "../src/LayoutsManager.vala"
			switch (0) {
#line 851 "LayoutsManager.c"
				default:
				{
					const gchar* _tmp65_;
#line 196 "../src/LayoutsManager.vala"
					_tmp65_ = manager_type;
#line 196 "../src/LayoutsManager.vala"
					g_warning ("LayoutsManager.vala:196: unrecognised input manager %s", _tmp65_);
#line 197 "../src/LayoutsManager.vala"
					_g_free0 (button_label);
#line 197 "../src/LayoutsManager.vala"
					_g_free0 (layout_variant);
#line 197 "../src/LayoutsManager.vala"
					_g_free0 (language);
#line 197 "../src/LayoutsManager.vala"
					continue;
#line 867 "LayoutsManager.c"
				}
			}
		}
#line 200 "../src/LayoutsManager.vala"
		_tmp67_ = layout_variant;
#line 200 "../src/LayoutsManager.vala"
		_tmp66_ = _tmp67_;
#line 200 "../src/LayoutsManager.vala"
		if (_tmp66_ == NULL) {
#line 200 "../src/LayoutsManager.vala"
			_tmp66_ = "";
#line 879 "LayoutsManager.c"
		}
#line 200 "../src/LayoutsManager.vala"
		_tmp68_ = g_strdup (_tmp66_);
#line 200 "../src/LayoutsManager.vala"
		_g_free0 (layout_variant);
#line 200 "../src/LayoutsManager.vala"
		layout_variant = _tmp68_;
#line 203 "../src/LayoutsManager.vala"
		_tmp69_ = button_label;
#line 203 "../src/LayoutsManager.vala"
		if (_tmp69_ == NULL) {
#line 891 "LayoutsManager.c"
			gchar* variant = NULL;
			gchar* _tmp70_;
			const gchar* _tmp71_;
			const gchar* _tmp74_;
			const gchar* _tmp75_;
			gchar* _tmp76_;
#line 205 "../src/LayoutsManager.vala"
			_tmp70_ = g_strdup ("");
#line 205 "../src/LayoutsManager.vala"
			variant = _tmp70_;
#line 206 "../src/LayoutsManager.vala"
			_tmp71_ = layout_variant;
#line 206 "../src/LayoutsManager.vala"
			if (g_strcmp0 (_tmp71_, "") != 0) {
#line 906 "LayoutsManager.c"
				const gchar* _tmp72_;
				gchar* _tmp73_;
#line 207 "../src/LayoutsManager.vala"
				_tmp72_ = layout_variant;
#line 207 "../src/LayoutsManager.vala"
				_tmp73_ = g_strdup_printf (" (%s)", _tmp72_);
#line 207 "../src/LayoutsManager.vala"
				_g_free0 (variant);
#line 207 "../src/LayoutsManager.vala"
				variant = _tmp73_;
#line 917 "LayoutsManager.c"
			}
#line 210 "../src/LayoutsManager.vala"
			_tmp74_ = language;
#line 210 "../src/LayoutsManager.vala"
			_tmp75_ = variant;
#line 210 "../src/LayoutsManager.vala"
			_tmp76_ = g_strconcat (_tmp74_, _tmp75_, NULL);
#line 210 "../src/LayoutsManager.vala"
			_g_free0 (button_label);
#line 210 "../src/LayoutsManager.vala"
			button_label = _tmp76_;
#line 203 "../src/LayoutsManager.vala"
			_g_free0 (variant);
#line 931 "LayoutsManager.c"
		}
#line 213 "../src/LayoutsManager.vala"
		_tmp77_ = g_variant_new ("u", i, NULL);
#line 213 "../src/LayoutsManager.vala"
		g_variant_ref_sink (_tmp77_);
#line 213 "../src/LayoutsManager.vala"
		action_target = _tmp77_;
#line 220 "../src/LayoutsManager.vala"
		_tmp79_ = layout_variant;
#line 220 "../src/LayoutsManager.vala"
		_tmp78_ = _tmp79_;
#line 220 "../src/LayoutsManager.vala"
		if (_tmp78_ == NULL) {
#line 220 "../src/LayoutsManager.vala"
			_tmp78_ = "";
#line 947 "LayoutsManager.c"
		}
#line 215 "../src/LayoutsManager.vala"
		_tmp80_ = button_label;
#line 215 "../src/LayoutsManager.vala"
		_tmp81_ = string_replace (_tmp80_, "_", "__");
#line 215 "../src/LayoutsManager.vala"
		_tmp82_ = _tmp81_;
#line 215 "../src/LayoutsManager.vala"
		_tmp83_ = manager_type;
#line 215 "../src/LayoutsManager.vala"
		_tmp84_ = source;
#line 215 "../src/LayoutsManager.vala"
		_tmp85_ = language;
#line 215 "../src/LayoutsManager.vala"
		_tmp86_ = action_target;
#line 215 "../src/LayoutsManager.vala"
		_tmp87_ = keyboard_widgets_layout_button_new (_tmp82_, _tmp83_, _tmp84_, _tmp85_, _tmp78_, i, "manager.change-layout", _tmp86_);
#line 215 "../src/LayoutsManager.vala"
		g_object_ref_sink (_tmp87_);
#line 215 "../src/LayoutsManager.vala"
		_g_object_unref0 (layout_button);
#line 215 "../src/LayoutsManager.vala"
		layout_button = _tmp87_;
#line 215 "../src/LayoutsManager.vala"
		_g_free0 (_tmp82_);
#line 229 "../src/LayoutsManager.vala"
		_tmp88_ = manager_type;
#line 229 "../src/LayoutsManager.vala"
		_tmp89_ = _tmp88_;
#line 229 "../src/LayoutsManager.vala"
		_tmp91_ = (NULL == _tmp89_) ? 0 : g_quark_from_string (_tmp89_);
#line 229 "../src/LayoutsManager.vala"
		if (_tmp91_ == ((0 != _tmp90_label0) ? _tmp90_label0 : (_tmp90_label0 = g_quark_from_static_string (KEYBOARD_WIDGETS_LAYOUT_MANAGER_XKB_MANAGER_TYPE)))) {
#line 229 "../src/LayoutsManager.vala"
			switch (0) {
#line 983 "LayoutsManager.c"
				default:
				{
					GtkBox* _tmp92_;
					KeyboardWidgetsLayoutButton* _tmp93_;
#line 231 "../src/LayoutsManager.vala"
					_tmp92_ = self->priv->xkb_box;
#line 231 "../src/LayoutsManager.vala"
					_tmp93_ = layout_button;
#line 231 "../src/LayoutsManager.vala"
					gtk_container_add ((GtkContainer*) _tmp92_, (GtkWidget*) _tmp93_);
#line 232 "../src/LayoutsManager.vala"
					break;
#line 996 "LayoutsManager.c"
				}
			}
		} else if (_tmp91_ == ((0 != _tmp90_label1) ? _tmp90_label1 : (_tmp90_label1 = g_quark_from_static_string (KEYBOARD_WIDGETS_LAYOUT_MANAGER_IBUS_MANAGER_TYPE)))) {
#line 229 "../src/LayoutsManager.vala"
			switch (0) {
#line 1002 "LayoutsManager.c"
				default:
				{
					GtkBox* _tmp94_;
					KeyboardWidgetsLayoutButton* _tmp95_;
#line 234 "../src/LayoutsManager.vala"
					_tmp94_ = self->priv->ibus_box;
#line 234 "../src/LayoutsManager.vala"
					_tmp95_ = layout_button;
#line 234 "../src/LayoutsManager.vala"
					gtk_container_add ((GtkContainer*) _tmp94_, (GtkWidget*) _tmp95_);
#line 235 "../src/LayoutsManager.vala"
					break;
#line 1015 "LayoutsManager.c"
				}
			}
		} else {
#line 229 "../src/LayoutsManager.vala"
			switch (0) {
#line 1021 "LayoutsManager.c"
				default:
				{
#line 237 "../src/LayoutsManager.vala"
					g_assert_not_reached ();
#line 1026 "LayoutsManager.c"
				}
			}
		}
#line 240 "../src/LayoutsManager.vala"
		_tmp96_ = i;
#line 240 "../src/LayoutsManager.vala"
		i = _tmp96_ + 1;
#line 157 "../src/LayoutsManager.vala"
		_g_variant_unref0 (action_target);
#line 157 "../src/LayoutsManager.vala"
		_g_free0 (button_label);
#line 157 "../src/LayoutsManager.vala"
		_g_free0 (layout_variant);
#line 157 "../src/LayoutsManager.vala"
		_g_free0 (language);
#line 1042 "LayoutsManager.c"
	}
#line 243 "../src/LayoutsManager.vala"
	_tmp97_ = self->priv->ibus_box;
#line 243 "../src/LayoutsManager.vala"
	_tmp98_ = gtk_container_get_children ((GtkContainer*) _tmp97_);
#line 243 "../src/LayoutsManager.vala"
	_tmp99_ = _tmp98_;
#line 243 "../src/LayoutsManager.vala"
	_tmp100_ = g_list_length (_tmp99_) > ((guint) 0);
#line 243 "../src/LayoutsManager.vala"
	(_tmp99_ == NULL) ? NULL : (_tmp99_ = (g_list_free (_tmp99_), NULL));
#line 243 "../src/LayoutsManager.vala"
	if (_tmp100_) {
#line 1056 "LayoutsManager.c"
		GtkRevealer* _tmp101_;
		GtkRevealer* _tmp102_;
		GraniteSwitchModelButton* _tmp103_;
		gboolean _tmp104_;
		gboolean _tmp105_;
#line 244 "../src/LayoutsManager.vala"
		_tmp101_ = self->priv->ibus_header_revealer;
#line 244 "../src/LayoutsManager.vala"
		gtk_revealer_set_reveal_child (_tmp101_, TRUE);
#line 245 "../src/LayoutsManager.vala"
		_tmp102_ = self->priv->ibus_box_revealer;
#line 245 "../src/LayoutsManager.vala"
		_tmp103_ = self->priv->ibus_header;
#line 245 "../src/LayoutsManager.vala"
		_tmp104_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp103_);
#line 245 "../src/LayoutsManager.vala"
		_tmp105_ = _tmp104_;
#line 245 "../src/LayoutsManager.vala"
		gtk_revealer_set_reveal_child (_tmp102_, _tmp105_);
#line 1076 "LayoutsManager.c"
	}
#line 248 "../src/LayoutsManager.vala"
	keyboard_widgets_layout_manager_set_active_layout_from_settings (self);
#line 249 "../src/LayoutsManager.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 133 "../src/LayoutsManager.vala"
	_g_free0 (source);
#line 133 "../src/LayoutsManager.vala"
	_g_free0 (manager_type);
#line 133 "../src/LayoutsManager.vala"
	_g_variant_iter_free0 (iter);
#line 133 "../src/LayoutsManager.vala"
	_g_object_unref0 (layout_button);
#line 133 "../src/LayoutsManager.vala"
	_g_variant_unref0 (source_list);
#line 1092 "LayoutsManager.c"
}

gchar*
keyboard_widgets_layout_manager_get_xml_rules_file_path (KeyboardWidgetsLayoutManager* self)
{
	const gchar* base_path = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 252 "../src/LayoutsManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 253 "../src/LayoutsManager.vala"
	_tmp0_ = g_getenv ("XKB_CONFIG_ROOT");
#line 253 "../src/LayoutsManager.vala"
	base_path = _tmp0_;
#line 254 "../src/LayoutsManager.vala"
	_tmp1_ = base_path;
#line 254 "../src/LayoutsManager.vala"
	if (_tmp1_ == NULL) {
#line 255 "../src/LayoutsManager.vala"
		base_path = CONSTANTS_XKB_BASE;
#line 1116 "LayoutsManager.c"
	}
#line 258 "../src/LayoutsManager.vala"
	_tmp2_ = base_path;
#line 258 "../src/LayoutsManager.vala"
	_tmp3_ = g_build_filename (_tmp2_, "rules", KEYBOARD_WIDGETS_LAYOUT_MANAGER_XKB_RULES_FILE, NULL);
#line 258 "../src/LayoutsManager.vala"
	result = _tmp3_;
#line 258 "../src/LayoutsManager.vala"
	return result;
#line 1126 "LayoutsManager.c"
}

static GVariant*
_variant_new1 (guint32 value)
{
#line 268 "../src/LayoutsManager.vala"
	return g_variant_ref_sink (g_variant_new_uint32 (value));
#line 1134 "LayoutsManager.c"
}

static void
keyboard_widgets_layout_manager_action_change_layout (KeyboardWidgetsLayoutManager* self,
                                                      GSimpleAction* action,
                                                      GVariant* parameter)
{
	guint32 current_source_index = 0U;
	guint32 _tmp0_ = 0U;
	GSettings* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	gboolean _tmp4_;
#line 261 "../src/LayoutsManager.vala"
	g_return_if_fail (self != NULL);
#line 261 "../src/LayoutsManager.vala"
	g_return_if_fail (action != NULL);
#line 263 "../src/LayoutsManager.vala"
	g_variant_get (parameter, "u", &_tmp0_, NULL);
#line 263 "../src/LayoutsManager.vala"
	current_source_index = _tmp0_;
#line 265 "../src/LayoutsManager.vala"
	keyboard_widgets_layout_manager_set_active_layout (self, current_source_index);
#line 267 "../src/LayoutsManager.vala"
	_tmp1_ = self->priv->settings;
#line 267 "../src/LayoutsManager.vala"
	_tmp2_ = g_settings_get_value (_tmp1_, "current");
#line 267 "../src/LayoutsManager.vala"
	_tmp3_ = _tmp2_;
#line 267 "../src/LayoutsManager.vala"
	_tmp4_ = _tmp3_ != current_source_index;
#line 267 "../src/LayoutsManager.vala"
	_g_variant_unref0 (_tmp3_);
#line 267 "../src/LayoutsManager.vala"
	if (_tmp4_) {
#line 1170 "LayoutsManager.c"
		GSettings* _tmp5_;
		GVariant* _tmp6_;
#line 268 "../src/LayoutsManager.vala"
		_tmp5_ = self->priv->settings;
#line 268 "../src/LayoutsManager.vala"
		_tmp6_ = _variant_new1 (current_source_index);
#line 268 "../src/LayoutsManager.vala"
		g_settings_set_value (_tmp5_, "current", _tmp6_);
#line 268 "../src/LayoutsManager.vala"
		_g_variant_unref0 (_tmp6_);
#line 1181 "LayoutsManager.c"
	}
}

static void
keyboard_widgets_layout_manager_set_ibus_engine (KeyboardWidgetsLayoutManager* self,
                                                 const gchar* manager,
                                                 const gchar* source)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 274 "../src/LayoutsManager.vala"
	static GQuark _tmp1_label0 = 0;
#line 274 "../src/LayoutsManager.vala"
	static GQuark _tmp1_label1 = 0;
#line 272 "../src/LayoutsManager.vala"
	g_return_if_fail (self != NULL);
#line 272 "../src/LayoutsManager.vala"
	g_return_if_fail (manager != NULL);
#line 272 "../src/LayoutsManager.vala"
	g_return_if_fail (source != NULL);
#line 274 "../src/LayoutsManager.vala"
	_tmp0_ = manager;
#line 274 "../src/LayoutsManager.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 274 "../src/LayoutsManager.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string (KEYBOARD_WIDGETS_LAYOUT_MANAGER_XKB_MANAGER_TYPE)))) {
#line 274 "../src/LayoutsManager.vala"
		switch (0) {
#line 1210 "LayoutsManager.c"
			default:
			{
				IBusBus* _tmp3_;
#line 277 "../src/LayoutsManager.vala"
				_tmp3_ = self->priv->bus;
#line 277 "../src/LayoutsManager.vala"
				ibus_bus_set_global_engine (_tmp3_, "xkb:us::eng");
#line 278 "../src/LayoutsManager.vala"
				break;
#line 1220 "LayoutsManager.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string (KEYBOARD_WIDGETS_LAYOUT_MANAGER_IBUS_MANAGER_TYPE)))) {
#line 274 "../src/LayoutsManager.vala"
		switch (0) {
#line 1226 "LayoutsManager.c"
			default:
			{
				IBusBus* _tmp4_;
#line 280 "../src/LayoutsManager.vala"
				_tmp4_ = self->priv->bus;
#line 280 "../src/LayoutsManager.vala"
				ibus_bus_set_global_engine (_tmp4_, source);
#line 281 "../src/LayoutsManager.vala"
				break;
#line 1236 "LayoutsManager.c"
			}
		}
	} else {
#line 274 "../src/LayoutsManager.vala"
		switch (0) {
#line 1242 "LayoutsManager.c"
			default:
			{
#line 283 "../src/LayoutsManager.vala"
				g_warning ("LayoutsManager.vala:283: unrecognised input manager %s", manager);
#line 284 "../src/LayoutsManager.vala"
				break;
#line 1249 "LayoutsManager.c"
			}
		}
	}
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 1265 "LayoutsManager.c"
}

gchar*
keyboard_widgets_layout_manager_get_name_for_xkb_layout (KeyboardWidgetsLayoutManager* self,
                                                         const gchar* language,
                                                         const gchar* variant)
{
	xmlDoc* doc = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	xmlDoc* _tmp2_;
	xmlDoc* _tmp3_;
	xmlDoc* _tmp4_;
	xmlXPathContext* cntx = NULL;
	xmlDoc* _tmp5_;
	xmlXPathContext* _tmp6_;
	gchar* xpath = NULL;
	gchar* _tmp7_;
	xmlXPathObject* res = NULL;
	xmlXPathContext* _tmp13_;
	const gchar* _tmp14_;
	xmlXPathObject* _tmp15_;
	xmlXPathObject* _tmp16_;
	gboolean _tmp18_ = FALSE;
	xmlXPathObject* _tmp19_;
	gchar* name = NULL;
	xmlNode* node = NULL;
	xmlXPathObject* _tmp24_;
	xmlNodeSet* _tmp25_;
	xmlNode* _tmp26_;
	xmlNode* _tmp27_;
	xmlXPathObject* _tmp32_;
	xmlDoc* _tmp33_;
	gchar* result;
#line 288 "../src/LayoutsManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 288 "../src/LayoutsManager.vala"
	g_return_val_if_fail (language != NULL, NULL);
#line 289 "../src/LayoutsManager.vala"
	g_debug ("LayoutsManager.vala:289: get_name_for_xkb_layout (%s, %s)", language, variant);
#line 290 "../src/LayoutsManager.vala"
	_tmp0_ = keyboard_widgets_layout_manager_get_xml_rules_file_path (self);
#line 290 "../src/LayoutsManager.vala"
	_tmp1_ = _tmp0_;
#line 290 "../src/LayoutsManager.vala"
	_tmp2_ = xmlParseFile (_tmp1_);
#line 290 "../src/LayoutsManager.vala"
	_tmp3_ = _tmp2_;
#line 290 "../src/LayoutsManager.vala"
	_g_free0 (_tmp1_);
#line 290 "../src/LayoutsManager.vala"
	doc = _tmp3_;
#line 291 "../src/LayoutsManager.vala"
	_tmp4_ = doc;
#line 291 "../src/LayoutsManager.vala"
	if (_tmp4_ == NULL) {
#line 292 "../src/LayoutsManager.vala"
		g_critical ("LayoutsManager.vala:292: '%s' not found or permissions incorrect\n", KEYBOARD_WIDGETS_LAYOUT_MANAGER_XKB_RULES_FILE);
#line 293 "../src/LayoutsManager.vala"
		result = NULL;
#line 293 "../src/LayoutsManager.vala"
		return result;
#line 1328 "LayoutsManager.c"
	}
#line 296 "../src/LayoutsManager.vala"
	_tmp5_ = doc;
#line 296 "../src/LayoutsManager.vala"
	_tmp6_ = xmlXPathNewContext (_tmp5_);
#line 296 "../src/LayoutsManager.vala"
	cntx = _tmp6_;
#line 297 "../src/LayoutsManager.vala"
	_tmp7_ = g_strdup ("");
#line 297 "../src/LayoutsManager.vala"
	xpath = _tmp7_;
#line 299 "../src/LayoutsManager.vala"
	if (variant == NULL) {
#line 1342 "LayoutsManager.c"
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 300 "../src/LayoutsManager.vala"
		_tmp8_ = string_to_string (language);
#line 300 "../src/LayoutsManager.vala"
		_tmp9_ = g_strconcat ("/xkbConfigRegistry/layoutList/layout/configItem/name[text()='", _tmp8_, "']/../description", NULL);
#line 300 "../src/LayoutsManager.vala"
		_g_free0 (xpath);
#line 300 "../src/LayoutsManager.vala"
		xpath = _tmp9_;
#line 1353 "LayoutsManager.c"
	} else {
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
#line 302 "../src/LayoutsManager.vala"
		_tmp10_ = string_to_string (language);
#line 302 "../src/LayoutsManager.vala"
		_tmp11_ = string_to_string (variant);
#line 302 "../src/LayoutsManager.vala"
		_tmp12_ = g_strconcat ("/xkbConfigRegistry/layoutList/layout/configItem/name[text()='", _tmp10_, "']/../../variantList/variant/configItem/name[text()='", _tmp11_, "']/../description", NULL);
#line 302 "../src/LayoutsManager.vala"
		_g_free0 (xpath);
#line 302 "../src/LayoutsManager.vala"
		xpath = _tmp12_;
#line 1368 "LayoutsManager.c"
	}
#line 305 "../src/LayoutsManager.vala"
	_tmp13_ = cntx;
#line 305 "../src/LayoutsManager.vala"
	_tmp14_ = xpath;
#line 305 "../src/LayoutsManager.vala"
	_tmp15_ = xmlXPathEvalExpression ((xmlChar*) _tmp14_, _tmp13_);
#line 305 "../src/LayoutsManager.vala"
	res = _tmp15_;
#line 307 "../src/LayoutsManager.vala"
	_tmp16_ = res;
#line 307 "../src/LayoutsManager.vala"
	if (_tmp16_ == NULL) {
#line 1382 "LayoutsManager.c"
		xmlDoc* _tmp17_;
#line 308 "../src/LayoutsManager.vala"
		_tmp17_ = doc;
#line 308 "../src/LayoutsManager.vala"
		_xmlFreeDoc0 (_tmp17_);
#line 309 "../src/LayoutsManager.vala"
		g_critical ("LayoutsManager.vala:309: Unable to parse '%s'", KEYBOARD_WIDGETS_LAYOUT_MANAGER_XKB_RULES_FILE);
#line 310 "../src/LayoutsManager.vala"
		result = NULL;
#line 310 "../src/LayoutsManager.vala"
		_g_free0 (xpath);
#line 310 "../src/LayoutsManager.vala"
		_xmlXPathFreeContext0 (cntx);
#line 310 "../src/LayoutsManager.vala"
		return result;
#line 1398 "LayoutsManager.c"
	}
#line 313 "../src/LayoutsManager.vala"
	_tmp19_ = res;
#line 313 "../src/LayoutsManager.vala"
	if (_tmp19_->type != XPATH_NODESET) {
#line 313 "../src/LayoutsManager.vala"
		_tmp18_ = TRUE;
#line 1406 "LayoutsManager.c"
	} else {
		xmlXPathObject* _tmp20_;
		xmlNodeSet* _tmp21_;
#line 313 "../src/LayoutsManager.vala"
		_tmp20_ = res;
#line 313 "../src/LayoutsManager.vala"
		_tmp21_ = _tmp20_->nodesetval;
#line 313 "../src/LayoutsManager.vala"
		_tmp18_ = _tmp21_ == NULL;
#line 1416 "LayoutsManager.c"
	}
#line 313 "../src/LayoutsManager.vala"
	if (_tmp18_) {
#line 1420 "LayoutsManager.c"
		xmlXPathObject* _tmp22_;
		xmlDoc* _tmp23_;
#line 314 "../src/LayoutsManager.vala"
		_tmp22_ = res;
#line 314 "../src/LayoutsManager.vala"
		_xmlXPathFreeObject0 (_tmp22_);
#line 315 "../src/LayoutsManager.vala"
		_tmp23_ = doc;
#line 315 "../src/LayoutsManager.vala"
		_xmlFreeDoc0 (_tmp23_);
#line 316 "../src/LayoutsManager.vala"
		g_warning ("LayoutsManager.vala:316: No name for %s: %s found in '%s'", language, variant, KEYBOARD_WIDGETS_LAYOUT_MANAGER_XKB_RULES_FILE);
#line 317 "../src/LayoutsManager.vala"
		result = NULL;
#line 317 "../src/LayoutsManager.vala"
		_g_free0 (xpath);
#line 317 "../src/LayoutsManager.vala"
		_xmlXPathFreeContext0 (cntx);
#line 317 "../src/LayoutsManager.vala"
		return result;
#line 1441 "LayoutsManager.c"
	}
#line 320 "../src/LayoutsManager.vala"
	name = NULL;
#line 321 "../src/LayoutsManager.vala"
	_tmp24_ = res;
#line 321 "../src/LayoutsManager.vala"
	_tmp25_ = _tmp24_->nodesetval;
#line 321 "../src/LayoutsManager.vala"
	_tmp26_ = xmlXPathNodeSetItem (_tmp25_, 0);
#line 321 "../src/LayoutsManager.vala"
	node = _tmp26_;
#line 322 "../src/LayoutsManager.vala"
	_tmp27_ = node;
#line 322 "../src/LayoutsManager.vala"
	if (_tmp27_ != NULL) {
#line 1457 "LayoutsManager.c"
		xmlNode* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
#line 323 "../src/LayoutsManager.vala"
		_tmp28_ = node;
#line 323 "../src/LayoutsManager.vala"
		_tmp29_ = (gchar*) xmlNodeGetContent (_tmp28_);
#line 323 "../src/LayoutsManager.vala"
		_tmp30_ = _tmp29_;
#line 323 "../src/LayoutsManager.vala"
		_tmp31_ = g_strdup (g_dgettext ("xkeyboard-config", _tmp30_));
#line 323 "../src/LayoutsManager.vala"
		_g_free0 (name);
#line 323 "../src/LayoutsManager.vala"
		name = _tmp31_;
#line 323 "../src/LayoutsManager.vala"
		_g_free0 (_tmp30_);
#line 1476 "LayoutsManager.c"
	}
#line 326 "../src/LayoutsManager.vala"
	_tmp32_ = res;
#line 326 "../src/LayoutsManager.vala"
	_xmlXPathFreeObject0 (_tmp32_);
#line 327 "../src/LayoutsManager.vala"
	_tmp33_ = doc;
#line 327 "../src/LayoutsManager.vala"
	_xmlFreeDoc0 (_tmp33_);
#line 328 "../src/LayoutsManager.vala"
	result = name;
#line 328 "../src/LayoutsManager.vala"
	_g_free0 (xpath);
#line 328 "../src/LayoutsManager.vala"
	_xmlXPathFreeContext0 (cntx);
#line 328 "../src/LayoutsManager.vala"
	return result;
#line 1494 "LayoutsManager.c"
}

gchar*
keyboard_widgets_layout_manager_get_current_with_variant (KeyboardWidgetsLayoutManager* self)
{
	const gchar* _tmp0_;
	gchar* result;
#line 331 "../src/LayoutsManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 332 "../src/LayoutsManager.vala"
	_tmp0_ = self->priv->_current_layout_variant;
#line 332 "../src/LayoutsManager.vala"
	if (g_strcmp0 (_tmp0_, "") != 0) {
#line 1508 "LayoutsManager.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 333 "../src/LayoutsManager.vala"
		_tmp1_ = self->priv->_current_language_code;
#line 333 "../src/LayoutsManager.vala"
		_tmp2_ = g_strconcat (_tmp1_, "\t", NULL);
#line 333 "../src/LayoutsManager.vala"
		_tmp3_ = _tmp2_;
#line 333 "../src/LayoutsManager.vala"
		_tmp4_ = self->priv->_current_layout_variant;
#line 333 "../src/LayoutsManager.vala"
		_tmp5_ = g_strconcat (_tmp3_, _tmp4_, NULL);
#line 333 "../src/LayoutsManager.vala"
		_tmp6_ = _tmp5_;
#line 333 "../src/LayoutsManager.vala"
		_g_free0 (_tmp3_);
#line 333 "../src/LayoutsManager.vala"
		result = _tmp6_;
#line 333 "../src/LayoutsManager.vala"
		return result;
#line 1533 "LayoutsManager.c"
	} else {
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 335 "../src/LayoutsManager.vala"
		_tmp7_ = self->priv->_current_language_code;
#line 335 "../src/LayoutsManager.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 335 "../src/LayoutsManager.vala"
		result = _tmp8_;
#line 335 "../src/LayoutsManager.vala"
		return result;
#line 1545 "LayoutsManager.c"
	}
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 339 "../src/LayoutsManager.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 339 "../src/LayoutsManager.vala"
	return _data1_;
#line 1556 "LayoutsManager.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 339 "../src/LayoutsManager.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 1566 "LayoutsManager.c"
		KeyboardWidgetsLayoutManager* self;
#line 339 "../src/LayoutsManager.vala"
		self = _data1_->self;
#line 339 "../src/LayoutsManager.vala"
		_g_free0 (_data1_->ibus_label);
#line 339 "../src/LayoutsManager.vala"
		_g_free0 (_data1_->xkb_label);
#line 339 "../src/LayoutsManager.vala"
		_g_object_unref0 (self);
#line 339 "../src/LayoutsManager.vala"
		g_slice_free (Block1Data, _data1_);
#line 1578 "LayoutsManager.c"
	}
}

static void
__lambda8_ (Block1Data* _data1_,
            GtkWidget* child)
{
	KeyboardWidgetsLayoutManager* self;
	KeyboardWidgetsLayoutButton* row = NULL;
	KeyboardWidgetsLayoutButton* _tmp0_;
	KeyboardWidgetsLayoutButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 343 "../src/LayoutsManager.vala"
	self = _data1_->self;
#line 343 "../src/LayoutsManager.vala"
	g_return_if_fail (child != NULL);
#line 344 "../src/LayoutsManager.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (child, KEYBOARD_WIDGETS_TYPE_LAYOUT_BUTTON, KeyboardWidgetsLayoutButton));
#line 344 "../src/LayoutsManager.vala"
	row = _tmp0_;
#line 345 "../src/LayoutsManager.vala"
	_tmp1_ = row;
#line 345 "../src/LayoutsManager.vala"
	_tmp2_ = keyboard_widgets_layout_button_get_active (_tmp1_);
#line 345 "../src/LayoutsManager.vala"
	_tmp3_ = _tmp2_;
#line 345 "../src/LayoutsManager.vala"
	if (_tmp3_) {
#line 1608 "LayoutsManager.c"
		KeyboardWidgetsLayoutButton* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 346 "../src/LayoutsManager.vala"
		_tmp4_ = row;
#line 346 "../src/LayoutsManager.vala"
		_tmp5_ = keyboard_widgets_layout_button_get_description (_tmp4_);
#line 346 "../src/LayoutsManager.vala"
		_tmp6_ = _tmp5_;
#line 346 "../src/LayoutsManager.vala"
		_tmp7_ = _tmp6_;
#line 346 "../src/LayoutsManager.vala"
		_tmp8_ = g_strdup_printf (_ ("Keyboard Layout: %s"), _tmp7_);
#line 346 "../src/LayoutsManager.vala"
		_g_free0 (_data1_->xkb_label);
#line 346 "../src/LayoutsManager.vala"
		_data1_->xkb_label = _tmp8_;
#line 346 "../src/LayoutsManager.vala"
		_g_free0 (_tmp7_);
#line 1630 "LayoutsManager.c"
	}
#line 343 "../src/LayoutsManager.vala"
	_g_object_unref0 (row);
#line 1634 "LayoutsManager.c"
}

static void
___lambda8__gfunc (gconstpointer data,
                   gpointer self)
{
#line 343 "../src/LayoutsManager.vala"
	__lambda8_ (self, (GtkWidget*) data);
#line 1643 "LayoutsManager.c"
}

static void
__lambda9_ (Block1Data* _data1_,
            GtkWidget* child)
{
	KeyboardWidgetsLayoutManager* self;
	KeyboardWidgetsLayoutButton* row = NULL;
	KeyboardWidgetsLayoutButton* _tmp0_;
	KeyboardWidgetsLayoutButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 350 "../src/LayoutsManager.vala"
	self = _data1_->self;
#line 350 "../src/LayoutsManager.vala"
	g_return_if_fail (child != NULL);
#line 351 "../src/LayoutsManager.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (child, KEYBOARD_WIDGETS_TYPE_LAYOUT_BUTTON, KeyboardWidgetsLayoutButton));
#line 351 "../src/LayoutsManager.vala"
	row = _tmp0_;
#line 352 "../src/LayoutsManager.vala"
	_tmp1_ = row;
#line 352 "../src/LayoutsManager.vala"
	_tmp2_ = keyboard_widgets_layout_button_get_active (_tmp1_);
#line 352 "../src/LayoutsManager.vala"
	_tmp3_ = _tmp2_;
#line 352 "../src/LayoutsManager.vala"
	if (_tmp3_) {
#line 1672 "LayoutsManager.c"
		KeyboardWidgetsLayoutButton* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 353 "../src/LayoutsManager.vala"
		_tmp4_ = row;
#line 353 "../src/LayoutsManager.vala"
		_tmp5_ = keyboard_widgets_layout_button_get_description (_tmp4_);
#line 353 "../src/LayoutsManager.vala"
		_tmp6_ = _tmp5_;
#line 353 "../src/LayoutsManager.vala"
		_tmp7_ = _tmp6_;
#line 353 "../src/LayoutsManager.vala"
		_tmp8_ = g_strdup_printf (_ ("Input Method: %s"), _tmp7_);
#line 353 "../src/LayoutsManager.vala"
		_g_free0 (_data1_->ibus_label);
#line 353 "../src/LayoutsManager.vala"
		_data1_->ibus_label = _tmp8_;
#line 353 "../src/LayoutsManager.vala"
		_g_free0 (_tmp7_);
#line 1694 "LayoutsManager.c"
	}
#line 350 "../src/LayoutsManager.vala"
	_g_object_unref0 (row);
#line 1698 "LayoutsManager.c"
}

static void
___lambda9__gfunc (gconstpointer data,
                   gpointer self)
{
#line 350 "../src/LayoutsManager.vala"
	__lambda9_ (self, (GtkWidget*) data);
#line 1707 "LayoutsManager.c"
}

gchar*
keyboard_widgets_layout_manager_get_current_description (KeyboardWidgetsLayoutManager* self)
{
	Block1Data* _data1_;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GtkBox* _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
	GtkBox* _tmp5_;
	GList* _tmp6_;
	GList* _tmp7_;
	const gchar* _tmp8_;
	gchar* result;
#line 339 "../src/LayoutsManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 339 "../src/LayoutsManager.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 339 "../src/LayoutsManager.vala"
	_data1_->_ref_count_ = 1;
#line 339 "../src/LayoutsManager.vala"
	_data1_->self = g_object_ref (self);
#line 340 "../src/LayoutsManager.vala"
	_tmp0_ = g_strdup (_ ("Default keyboard layout"));
#line 340 "../src/LayoutsManager.vala"
	_data1_->xkb_label = _tmp0_;
#line 341 "../src/LayoutsManager.vala"
	_tmp1_ = g_strdup ("");
#line 341 "../src/LayoutsManager.vala"
	_data1_->ibus_label = _tmp1_;
#line 343 "../src/LayoutsManager.vala"
	_tmp2_ = self->priv->xkb_box;
#line 343 "../src/LayoutsManager.vala"
	_tmp3_ = gtk_container_get_children ((GtkContainer*) _tmp2_);
#line 343 "../src/LayoutsManager.vala"
	_tmp4_ = _tmp3_;
#line 343 "../src/LayoutsManager.vala"
	g_list_foreach (_tmp4_, ___lambda8__gfunc, _data1_);
#line 343 "../src/LayoutsManager.vala"
	(_tmp4_ == NULL) ? NULL : (_tmp4_ = (g_list_free (_tmp4_), NULL));
#line 350 "../src/LayoutsManager.vala"
	_tmp5_ = self->priv->ibus_box;
#line 350 "../src/LayoutsManager.vala"
	_tmp6_ = gtk_container_get_children ((GtkContainer*) _tmp5_);
#line 350 "../src/LayoutsManager.vala"
	_tmp7_ = _tmp6_;
#line 350 "../src/LayoutsManager.vala"
	g_list_foreach (_tmp7_, ___lambda9__gfunc, _data1_);
#line 350 "../src/LayoutsManager.vala"
	(_tmp7_ == NULL) ? NULL : (_tmp7_ = (g_list_free (_tmp7_), NULL));
#line 357 "../src/LayoutsManager.vala"
	_tmp8_ = _data1_->ibus_label;
#line 357 "../src/LayoutsManager.vala"
	if (g_strcmp0 (_tmp8_, "") != 0) {
#line 1764 "LayoutsManager.c"
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 358 "../src/LayoutsManager.vala"
		_tmp9_ = _data1_->ibus_label;
#line 358 "../src/LayoutsManager.vala"
		_tmp10_ = _data1_->xkb_label;
#line 358 "../src/LayoutsManager.vala"
		_tmp11_ = g_strdup_printf ("%s\n%s", _tmp9_, _tmp10_);
#line 358 "../src/LayoutsManager.vala"
		result = _tmp11_;
#line 358 "../src/LayoutsManager.vala"
		block1_data_unref (_data1_);
#line 358 "../src/LayoutsManager.vala"
		_data1_ = NULL;
#line 358 "../src/LayoutsManager.vala"
		return result;
#line 1782 "LayoutsManager.c"
	} else {
		const gchar* _tmp12_;
		gchar* _tmp13_;
#line 360 "../src/LayoutsManager.vala"
		_tmp12_ = _data1_->xkb_label;
#line 360 "../src/LayoutsManager.vala"
		_tmp13_ = g_strdup (_tmp12_);
#line 360 "../src/LayoutsManager.vala"
		result = _tmp13_;
#line 360 "../src/LayoutsManager.vala"
		block1_data_unref (_data1_);
#line 360 "../src/LayoutsManager.vala"
		_data1_ = NULL;
#line 360 "../src/LayoutsManager.vala"
		return result;
#line 1798 "LayoutsManager.c"
	}
}

static GVariant*
_variant_new2 (guint32 value)
{
#line 371 "../src/LayoutsManager.vala"
	return g_variant_ref_sink (g_variant_new_uint32 (value));
#line 1807 "LayoutsManager.c"
}

void
keyboard_widgets_layout_manager_next (KeyboardWidgetsLayoutManager* self)
{
	GVariant* current = NULL;
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	guint32 next = 0U;
	GVariant* _tmp2_;
	GtkBox* _tmp3_;
	GList* _tmp4_;
	GList* _tmp5_;
	GtkBox* _tmp6_;
	GList* _tmp7_;
	GList* _tmp8_;
	gboolean _tmp9_;
	GSettings* _tmp10_;
	GVariant* _tmp11_;
#line 364 "../src/LayoutsManager.vala"
	g_return_if_fail (self != NULL);
#line 365 "../src/LayoutsManager.vala"
	_tmp0_ = self->priv->settings;
#line 365 "../src/LayoutsManager.vala"
	_tmp1_ = g_settings_get_value (_tmp0_, "current");
#line 365 "../src/LayoutsManager.vala"
	current = _tmp1_;
#line 366 "../src/LayoutsManager.vala"
	_tmp2_ = current;
#line 366 "../src/LayoutsManager.vala"
	next = g_variant_get_uint32 (_tmp2_) + 1;
#line 367 "../src/LayoutsManager.vala"
	_tmp3_ = self->priv->xkb_box;
#line 367 "../src/LayoutsManager.vala"
	_tmp4_ = gtk_container_get_children ((GtkContainer*) _tmp3_);
#line 367 "../src/LayoutsManager.vala"
	_tmp5_ = _tmp4_;
#line 367 "../src/LayoutsManager.vala"
	_tmp6_ = self->priv->ibus_box;
#line 367 "../src/LayoutsManager.vala"
	_tmp7_ = gtk_container_get_children ((GtkContainer*) _tmp6_);
#line 367 "../src/LayoutsManager.vala"
	_tmp8_ = _tmp7_;
#line 367 "../src/LayoutsManager.vala"
	_tmp9_ = next >= ((guint32) (g_list_length (_tmp5_) + g_list_length (_tmp8_)));
#line 367 "../src/LayoutsManager.vala"
	(_tmp8_ == NULL) ? NULL : (_tmp8_ = (g_list_free (_tmp8_), NULL));
#line 367 "../src/LayoutsManager.vala"
	(_tmp5_ == NULL) ? NULL : (_tmp5_ = (g_list_free (_tmp5_), NULL));
#line 367 "../src/LayoutsManager.vala"
	if (_tmp9_) {
#line 368 "../src/LayoutsManager.vala"
		next = (guint32) 0;
#line 1861 "LayoutsManager.c"
	}
#line 371 "../src/LayoutsManager.vala"
	_tmp10_ = self->priv->settings;
#line 371 "../src/LayoutsManager.vala"
	_tmp11_ = _variant_new2 (next);
#line 371 "../src/LayoutsManager.vala"
	g_settings_set_value (_tmp10_, "current", _tmp11_);
#line 371 "../src/LayoutsManager.vala"
	_g_variant_unref0 (_tmp11_);
#line 364 "../src/LayoutsManager.vala"
	_g_variant_unref0 (current);
#line 1873 "LayoutsManager.c"
}

static void
keyboard_widgets_layout_manager_set_active_layout_from_settings (KeyboardWidgetsLayoutManager* self)
{
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
#line 374 "../src/LayoutsManager.vala"
	g_return_if_fail (self != NULL);
#line 375 "../src/LayoutsManager.vala"
	_tmp0_ = self->priv->settings;
#line 375 "../src/LayoutsManager.vala"
	_tmp1_ = g_settings_get_value (_tmp0_, "current");
#line 375 "../src/LayoutsManager.vala"
	_tmp2_ = _tmp1_;
#line 375 "../src/LayoutsManager.vala"
	keyboard_widgets_layout_manager_set_active_layout (self, g_variant_get_uint32 (_tmp2_));
#line 375 "../src/LayoutsManager.vala"
	_g_variant_unref0 (_tmp2_);
#line 1894 "LayoutsManager.c"
}

static GVariant*
_variant_new3 (guint32 value)
{
#line 382 "../src/LayoutsManager.vala"
	return g_variant_ref_sink (g_variant_new_uint32 (value));
#line 1902 "LayoutsManager.c"
}

static void
keyboard_widgets_layout_manager_set_active_layout_to_xkb (KeyboardWidgetsLayoutManager* self)
{
	GtkBox* _tmp0_;
	GList* _tmp1_;
#line 378 "../src/LayoutsManager.vala"
	g_return_if_fail (self != NULL);
#line 379 "../src/LayoutsManager.vala"
	_tmp0_ = self->priv->xkb_box;
#line 379 "../src/LayoutsManager.vala"
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
#line 1916 "LayoutsManager.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 379 "../src/LayoutsManager.vala"
		child_collection = _tmp1_;
#line 379 "../src/LayoutsManager.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 1924 "LayoutsManager.c"
			GtkWidget* _tmp2_;
			GtkWidget* child = NULL;
#line 379 "../src/LayoutsManager.vala"
			_tmp2_ = _g_object_ref0 ((GtkWidget*) child_it->data);
#line 379 "../src/LayoutsManager.vala"
			child = _tmp2_;
#line 1931 "LayoutsManager.c"
			{
				KeyboardWidgetsLayoutButton* button = NULL;
				GtkWidget* _tmp3_;
				KeyboardWidgetsLayoutButton* _tmp4_;
				KeyboardWidgetsLayoutButton* _tmp5_;
				gboolean _tmp6_;
				gboolean _tmp7_;
#line 380 "../src/LayoutsManager.vala"
				_tmp3_ = child;
#line 380 "../src/LayoutsManager.vala"
				_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, KEYBOARD_WIDGETS_TYPE_LAYOUT_BUTTON, KeyboardWidgetsLayoutButton));
#line 380 "../src/LayoutsManager.vala"
				button = _tmp4_;
#line 381 "../src/LayoutsManager.vala"
				_tmp5_ = button;
#line 381 "../src/LayoutsManager.vala"
				_tmp6_ = keyboard_widgets_layout_button_get_active (_tmp5_);
#line 381 "../src/LayoutsManager.vala"
				_tmp7_ = _tmp6_;
#line 381 "../src/LayoutsManager.vala"
				if (_tmp7_) {
#line 1953 "LayoutsManager.c"
					GSettings* _tmp8_;
					KeyboardWidgetsLayoutButton* _tmp9_;
					guint32 _tmp10_;
					guint32 _tmp11_;
					GVariant* _tmp12_;
					KeyboardWidgetsLayoutButton* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
#line 382 "../src/LayoutsManager.vala"
					_tmp8_ = self->priv->settings;
#line 382 "../src/LayoutsManager.vala"
					_tmp9_ = button;
#line 382 "../src/LayoutsManager.vala"
					_tmp10_ = keyboard_widgets_layout_button_get_index (_tmp9_);
#line 382 "../src/LayoutsManager.vala"
					_tmp11_ = _tmp10_;
#line 382 "../src/LayoutsManager.vala"
					_tmp12_ = _variant_new3 (_tmp11_);
#line 382 "../src/LayoutsManager.vala"
					g_settings_set_value (_tmp8_, "current", _tmp12_);
#line 382 "../src/LayoutsManager.vala"
					_g_variant_unref0 (_tmp12_);
#line 383 "../src/LayoutsManager.vala"
					_tmp13_ = button;
#line 383 "../src/LayoutsManager.vala"
					_tmp14_ = keyboard_widgets_layout_button_get_source (_tmp13_);
#line 383 "../src/LayoutsManager.vala"
					_tmp15_ = _tmp14_;
#line 383 "../src/LayoutsManager.vala"
					keyboard_widgets_layout_manager_set_ibus_engine (self, KEYBOARD_WIDGETS_LAYOUT_MANAGER_XKB_MANAGER_TYPE, _tmp15_);
#line 1984 "LayoutsManager.c"
				}
#line 379 "../src/LayoutsManager.vala"
				_g_object_unref0 (button);
#line 379 "../src/LayoutsManager.vala"
				_g_object_unref0 (child);
#line 1990 "LayoutsManager.c"
			}
		}
#line 379 "../src/LayoutsManager.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 1995 "LayoutsManager.c"
	}
}

static void
keyboard_widgets_layout_manager_set_active_layout (KeyboardWidgetsLayoutManager* self,
                                                   guint32 index)
{
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
#line 388 "../src/LayoutsManager.vala"
	g_return_if_fail (self != NULL);
#line 389 "../src/LayoutsManager.vala"
	_tmp0_ = self->priv->xkb_box;
#line 389 "../src/LayoutsManager.vala"
	keyboard_widgets_layout_manager_set_layout_active_in_box (self, _tmp0_, (guint) index, FALSE);
#line 390 "../src/LayoutsManager.vala"
	_tmp1_ = self->priv->ibus_box;
#line 390 "../src/LayoutsManager.vala"
	keyboard_widgets_layout_manager_set_layout_active_in_box (self, _tmp1_, (guint) index, TRUE);
#line 392 "../src/LayoutsManager.vala"
	g_signal_emit (self, keyboard_widgets_layout_manager_signals[KEYBOARD_WIDGETS_LAYOUT_MANAGER_UPDATED_SIGNAL], 0);
#line 2017 "LayoutsManager.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 395 "../src/LayoutsManager.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 395 "../src/LayoutsManager.vala"
	return _data2_;
#line 2027 "LayoutsManager.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 395 "../src/LayoutsManager.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 2037 "LayoutsManager.c"
		KeyboardWidgetsLayoutManager* self;
#line 395 "../src/LayoutsManager.vala"
		self = _data2_->self;
#line 395 "../src/LayoutsManager.vala"
		_g_object_unref0 (_data2_->previously_active_button);
#line 395 "../src/LayoutsManager.vala"
		_g_object_unref0 (self);
#line 395 "../src/LayoutsManager.vala"
		g_slice_free (Block2Data, _data2_);
#line 2047 "LayoutsManager.c"
	}
}

static void
__lambda6_ (Block2Data* _data2_,
            GtkWidget* widget)
{
	KeyboardWidgetsLayoutManager* self;
	KeyboardWidgetsLayoutButton* button = NULL;
	KeyboardWidgetsLayoutButton* _tmp0_;
	KeyboardWidgetsLayoutButton* _tmp1_;
	guint32 _tmp2_;
	guint32 _tmp3_;
#line 400 "../src/LayoutsManager.vala"
	self = _data2_->self;
#line 400 "../src/LayoutsManager.vala"
	g_return_if_fail (widget != NULL);
#line 401 "../src/LayoutsManager.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (widget, KEYBOARD_WIDGETS_TYPE_LAYOUT_BUTTON, KeyboardWidgetsLayoutButton));
#line 401 "../src/LayoutsManager.vala"
	button = _tmp0_;
#line 403 "../src/LayoutsManager.vala"
	_tmp1_ = button;
#line 403 "../src/LayoutsManager.vala"
	_tmp2_ = keyboard_widgets_layout_button_get_index (_tmp1_);
#line 403 "../src/LayoutsManager.vala"
	_tmp3_ = _tmp2_;
#line 403 "../src/LayoutsManager.vala"
	if (_tmp3_ == ((guint32) _data2_->index)) {
#line 2077 "LayoutsManager.c"
		KeyboardWidgetsLayoutButton* _tmp4_;
		KeyboardWidgetsLayoutButton* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		KeyboardWidgetsLayoutButton* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		IBusBus* _tmp11_;
#line 404 "../src/LayoutsManager.vala"
		_data2_->found = TRUE;
#line 405 "../src/LayoutsManager.vala"
		_tmp4_ = button;
#line 405 "../src/LayoutsManager.vala"
		keyboard_widgets_layout_button_set_active (_tmp4_, TRUE);
#line 406 "../src/LayoutsManager.vala"
		_tmp5_ = button;
#line 406 "../src/LayoutsManager.vala"
		_tmp6_ = keyboard_widgets_layout_button_get_language_code (_tmp5_);
#line 406 "../src/LayoutsManager.vala"
		_tmp7_ = _tmp6_;
#line 406 "../src/LayoutsManager.vala"
		keyboard_widgets_layout_manager_set_current_language_code (self, _tmp7_);
#line 407 "../src/LayoutsManager.vala"
		_tmp8_ = button;
#line 407 "../src/LayoutsManager.vala"
		_tmp9_ = keyboard_widgets_layout_button_get_layout_variant (_tmp8_);
#line 407 "../src/LayoutsManager.vala"
		_tmp10_ = _tmp9_;
#line 407 "../src/LayoutsManager.vala"
		keyboard_widgets_layout_manager_set_current_layout_variant (self, _tmp10_);
#line 408 "../src/LayoutsManager.vala"
		_tmp11_ = self->priv->bus;
#line 408 "../src/LayoutsManager.vala"
		if (ibus_bus_is_connected (_tmp11_)) {
#line 2112 "LayoutsManager.c"
			KeyboardWidgetsLayoutButton* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			KeyboardWidgetsLayoutButton* _tmp15_;
			const gchar* _tmp16_;
			const gchar* _tmp17_;
#line 409 "../src/LayoutsManager.vala"
			_tmp12_ = button;
#line 409 "../src/LayoutsManager.vala"
			_tmp13_ = keyboard_widgets_layout_button_get_manager_type (_tmp12_);
#line 409 "../src/LayoutsManager.vala"
			_tmp14_ = _tmp13_;
#line 409 "../src/LayoutsManager.vala"
			_tmp15_ = button;
#line 409 "../src/LayoutsManager.vala"
			_tmp16_ = keyboard_widgets_layout_button_get_source (_tmp15_);
#line 409 "../src/LayoutsManager.vala"
			_tmp17_ = _tmp16_;
#line 409 "../src/LayoutsManager.vala"
			keyboard_widgets_layout_manager_set_ibus_engine (self, _tmp14_, _tmp17_);
#line 2133 "LayoutsManager.c"
		}
	} else {
		KeyboardWidgetsLayoutButton* _tmp18_;
		gboolean _tmp19_;
		gboolean _tmp20_;
#line 411 "../src/LayoutsManager.vala"
		_tmp18_ = button;
#line 411 "../src/LayoutsManager.vala"
		_tmp19_ = keyboard_widgets_layout_button_get_active (_tmp18_);
#line 411 "../src/LayoutsManager.vala"
		_tmp20_ = _tmp19_;
#line 411 "../src/LayoutsManager.vala"
		if (_tmp20_) {
#line 2147 "LayoutsManager.c"
			KeyboardWidgetsLayoutButton* _tmp21_;
#line 412 "../src/LayoutsManager.vala"
			_tmp21_ = button;
#line 412 "../src/LayoutsManager.vala"
			button = NULL;
#line 412 "../src/LayoutsManager.vala"
			_g_object_unref0 (_data2_->previously_active_button);
#line 412 "../src/LayoutsManager.vala"
			_data2_->previously_active_button = _tmp21_;
#line 2157 "LayoutsManager.c"
		}
	}
#line 400 "../src/LayoutsManager.vala"
	_g_object_unref0 (button);
#line 2162 "LayoutsManager.c"
}

static void
___lambda6__gfunc (gconstpointer data,
                   gpointer self)
{
#line 400 "../src/LayoutsManager.vala"
	__lambda6_ (self, (GtkWidget*) data);
#line 2171 "LayoutsManager.c"
}

static void
____lambda7_ (KeyboardWidgetsLayoutManager* self,
              GtkWidget* widget)
{
#line 421 "../src/LayoutsManager.vala"
	g_return_if_fail (widget != NULL);
#line 422 "../src/LayoutsManager.vala"
	keyboard_widgets_layout_button_set_active (G_TYPE_CHECK_INSTANCE_CAST (widget, KEYBOARD_WIDGETS_TYPE_LAYOUT_BUTTON, KeyboardWidgetsLayoutButton), FALSE);
#line 2182 "LayoutsManager.c"
}

static void
_____lambda7__gfunc (gconstpointer data,
                     gpointer self)
{
#line 421 "../src/LayoutsManager.vala"
	____lambda7_ ((KeyboardWidgetsLayoutManager*) self, (GtkWidget*) data);
#line 2191 "LayoutsManager.c"
}

static void
keyboard_widgets_layout_manager_set_layout_active_in_box (KeyboardWidgetsLayoutManager* self,
                                                          GtkBox* layout_box,
                                                          guint index,
                                                          gboolean clear)
{
	Block2Data* _data2_;
	GList* children = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
#line 395 "../src/LayoutsManager.vala"
	g_return_if_fail (self != NULL);
#line 395 "../src/LayoutsManager.vala"
	g_return_if_fail (layout_box != NULL);
#line 395 "../src/LayoutsManager.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 395 "../src/LayoutsManager.vala"
	_data2_->_ref_count_ = 1;
#line 395 "../src/LayoutsManager.vala"
	_data2_->self = g_object_ref (self);
#line 395 "../src/LayoutsManager.vala"
	_data2_->index = index;
#line 396 "../src/LayoutsManager.vala"
	_tmp0_ = gtk_container_get_children ((GtkContainer*) layout_box);
#line 396 "../src/LayoutsManager.vala"
	children = _tmp0_;
#line 397 "../src/LayoutsManager.vala"
	_data2_->previously_active_button = NULL;
#line 398 "../src/LayoutsManager.vala"
	_data2_->found = FALSE;
#line 400 "../src/LayoutsManager.vala"
	_tmp1_ = children;
#line 400 "../src/LayoutsManager.vala"
	g_list_foreach (_tmp1_, ___lambda6__gfunc, _data2_);
#line 416 "../src/LayoutsManager.vala"
	if (_data2_->found) {
#line 2230 "LayoutsManager.c"
		KeyboardWidgetsLayoutButton* _tmp2_;
#line 417 "../src/LayoutsManager.vala"
		_tmp2_ = _data2_->previously_active_button;
#line 417 "../src/LayoutsManager.vala"
		if (_tmp2_ != NULL) {
#line 2236 "LayoutsManager.c"
			KeyboardWidgetsLayoutButton* _tmp3_;
#line 418 "../src/LayoutsManager.vala"
			_tmp3_ = _data2_->previously_active_button;
#line 418 "../src/LayoutsManager.vala"
			keyboard_widgets_layout_button_set_active (_tmp3_, FALSE);
#line 2242 "LayoutsManager.c"
		}
	} else {
#line 420 "../src/LayoutsManager.vala"
		if (clear) {
#line 2247 "LayoutsManager.c"
			GList* _tmp4_;
#line 421 "../src/LayoutsManager.vala"
			_tmp4_ = children;
#line 421 "../src/LayoutsManager.vala"
			g_list_foreach (_tmp4_, _____lambda7__gfunc, self);
#line 2253 "LayoutsManager.c"
		}
	}
#line 395 "../src/LayoutsManager.vala"
	(children == NULL) ? NULL : (children = (g_list_free (children), NULL));
#line 395 "../src/LayoutsManager.vala"
	block2_data_unref (_data2_);
#line 395 "../src/LayoutsManager.vala"
	_data2_ = NULL;
#line 2262 "LayoutsManager.c"
}

gboolean
keyboard_widgets_layout_manager_has_multiple_layouts (KeyboardWidgetsLayoutManager* self)
{
	GtkBox* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GtkBox* _tmp3_;
	GList* _tmp4_;
	GList* _tmp5_;
	gboolean _tmp6_;
	gboolean result;
#line 427 "../src/LayoutsManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 428 "../src/LayoutsManager.vala"
	_tmp0_ = self->priv->xkb_box;
#line 428 "../src/LayoutsManager.vala"
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
#line 428 "../src/LayoutsManager.vala"
	_tmp2_ = _tmp1_;
#line 428 "../src/LayoutsManager.vala"
	_tmp3_ = self->priv->ibus_box;
#line 428 "../src/LayoutsManager.vala"
	_tmp4_ = gtk_container_get_children ((GtkContainer*) _tmp3_);
#line 428 "../src/LayoutsManager.vala"
	_tmp5_ = _tmp4_;
#line 428 "../src/LayoutsManager.vala"
	_tmp6_ = (g_list_length (_tmp2_) + g_list_length (_tmp5_)) > ((guint) 1);
#line 428 "../src/LayoutsManager.vala"
	(_tmp5_ == NULL) ? NULL : (_tmp5_ = (g_list_free (_tmp5_), NULL));
#line 428 "../src/LayoutsManager.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_list_free (_tmp2_), NULL));
#line 428 "../src/LayoutsManager.vala"
	result = _tmp6_;
#line 428 "../src/LayoutsManager.vala"
	return result;
#line 2300 "LayoutsManager.c"
}

KeyboardWidgetsLayoutManager*
keyboard_widgets_layout_manager_construct (GType object_type)
{
	KeyboardWidgetsLayoutManager * self = NULL;
#line 19 "../src/LayoutsManager.vala"
	self = (KeyboardWidgetsLayoutManager*) g_object_new (object_type, NULL);
#line 19 "../src/LayoutsManager.vala"
	return self;
#line 2311 "LayoutsManager.c"
}

KeyboardWidgetsLayoutManager*
keyboard_widgets_layout_manager_new (void)
{
#line 19 "../src/LayoutsManager.vala"
	return keyboard_widgets_layout_manager_construct (KEYBOARD_WIDGETS_TYPE_LAYOUT_MANAGER);
#line 2319 "LayoutsManager.c"
}

const gchar*
keyboard_widgets_layout_manager_get_current_language_code (KeyboardWidgetsLayoutManager* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 24 "../src/LayoutsManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/LayoutsManager.vala"
	_tmp0_ = self->priv->_current_language_code;
#line 24 "../src/LayoutsManager.vala"
	result = _tmp0_;
#line 24 "../src/LayoutsManager.vala"
	return result;
#line 2335 "LayoutsManager.c"
}

void
keyboard_widgets_layout_manager_set_current_language_code (KeyboardWidgetsLayoutManager* self,
                                                           const gchar* value)
{
	gchar* old_value;
#line 24 "../src/LayoutsManager.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/LayoutsManager.vala"
	old_value = keyboard_widgets_layout_manager_get_current_language_code (self);
#line 24 "../src/LayoutsManager.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2349 "LayoutsManager.c"
		gchar* _tmp0_;
#line 24 "../src/LayoutsManager.vala"
		_tmp0_ = g_strdup (value);
#line 24 "../src/LayoutsManager.vala"
		_g_free0 (self->priv->_current_language_code);
#line 24 "../src/LayoutsManager.vala"
		self->priv->_current_language_code = _tmp0_;
#line 24 "../src/LayoutsManager.vala"
		g_object_notify_by_pspec ((GObject *) self, keyboard_widgets_layout_manager_properties[KEYBOARD_WIDGETS_LAYOUT_MANAGER_CURRENT_LANGUAGE_CODE_PROPERTY]);
#line 2359 "LayoutsManager.c"
	}
}

const gchar*
keyboard_widgets_layout_manager_get_current_layout_variant (KeyboardWidgetsLayoutManager* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 25 "../src/LayoutsManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/LayoutsManager.vala"
	_tmp0_ = self->priv->_current_layout_variant;
#line 25 "../src/LayoutsManager.vala"
	result = _tmp0_;
#line 25 "../src/LayoutsManager.vala"
	return result;
#line 2376 "LayoutsManager.c"
}

void
keyboard_widgets_layout_manager_set_current_layout_variant (KeyboardWidgetsLayoutManager* self,
                                                            const gchar* value)
{
	gchar* old_value;
#line 25 "../src/LayoutsManager.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/LayoutsManager.vala"
	old_value = keyboard_widgets_layout_manager_get_current_layout_variant (self);
#line 25 "../src/LayoutsManager.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2390 "LayoutsManager.c"
		gchar* _tmp0_;
#line 25 "../src/LayoutsManager.vala"
		_tmp0_ = g_strdup (value);
#line 25 "../src/LayoutsManager.vala"
		_g_free0 (self->priv->_current_layout_variant);
#line 25 "../src/LayoutsManager.vala"
		self->priv->_current_layout_variant = _tmp0_;
#line 25 "../src/LayoutsManager.vala"
		g_object_notify_by_pspec ((GObject *) self, keyboard_widgets_layout_manager_properties[KEYBOARD_WIDGETS_LAYOUT_MANAGER_CURRENT_LAYOUT_VARIANT_PROPERTY]);
#line 2400 "LayoutsManager.c"
	}
}

static void
_keyboard_widgets_layout_manager___lambda10_ (KeyboardWidgetsLayoutManager* self)
{
	GraniteSwitchModelButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 86 "../src/LayoutsManager.vala"
	_tmp0_ = self->priv->ibus_header;
#line 86 "../src/LayoutsManager.vala"
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
#line 86 "../src/LayoutsManager.vala"
	_tmp2_ = _tmp1_;
#line 86 "../src/LayoutsManager.vala"
	if (_tmp2_) {
#line 2418 "LayoutsManager.c"
		GtkRevealer* _tmp3_;
#line 87 "../src/LayoutsManager.vala"
		_tmp3_ = self->priv->ibus_box_revealer;
#line 87 "../src/LayoutsManager.vala"
		gtk_revealer_set_reveal_child (_tmp3_, TRUE);
#line 2424 "LayoutsManager.c"
	} else {
		GtkRevealer* _tmp4_;
#line 89 "../src/LayoutsManager.vala"
		_tmp4_ = self->priv->ibus_box_revealer;
#line 89 "../src/LayoutsManager.vala"
		gtk_revealer_set_reveal_child (_tmp4_, FALSE);
#line 90 "../src/LayoutsManager.vala"
		keyboard_widgets_layout_manager_set_active_layout_to_xkb (self);
#line 2433 "LayoutsManager.c"
	}
}

static void
__keyboard_widgets_layout_manager___lambda10__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                         gpointer self)
{
#line 85 "../src/LayoutsManager.vala"
	_keyboard_widgets_layout_manager___lambda10_ ((KeyboardWidgetsLayoutManager*) self);
#line 2443 "LayoutsManager.c"
}

static void
_keyboard_widgets_layout_manager___lambda11_ (KeyboardWidgetsLayoutManager* self)
{
#line 101 "../src/LayoutsManager.vala"
	keyboard_widgets_layout_manager_populate_layouts (self);
#line 2451 "LayoutsManager.c"
}

static void
__keyboard_widgets_layout_manager___lambda11__g_settings_changed (GSettings* _sender,
                                                                  const gchar* key,
                                                                  gpointer self)
{
#line 100 "../src/LayoutsManager.vala"
	_keyboard_widgets_layout_manager___lambda11_ ((KeyboardWidgetsLayoutManager*) self);
#line 2461 "LayoutsManager.c"
}

static void
_keyboard_widgets_layout_manager___lambda12_ (KeyboardWidgetsLayoutManager* self)
{
#line 105 "../src/LayoutsManager.vala"
	keyboard_widgets_layout_manager_populate_layouts (self);
#line 2469 "LayoutsManager.c"
}

static void
__keyboard_widgets_layout_manager___lambda12__ibus_bus_connected (IBusBus* _sender,
                                                                  gpointer self)
{
#line 104 "../src/LayoutsManager.vala"
	_keyboard_widgets_layout_manager___lambda12_ ((KeyboardWidgetsLayoutManager*) self);
#line 2478 "LayoutsManager.c"
}

static void
_keyboard_widgets_layout_manager___lambda13_ (KeyboardWidgetsLayoutManager* self)
{
#line 109 "../src/LayoutsManager.vala"
	keyboard_widgets_layout_manager_populate_layouts (self);
#line 2486 "LayoutsManager.c"
}

static void
__keyboard_widgets_layout_manager___lambda13__ibus_bus_disconnected (IBusBus* _sender,
                                                                     gpointer self)
{
#line 108 "../src/LayoutsManager.vala"
	_keyboard_widgets_layout_manager___lambda13_ ((KeyboardWidgetsLayoutManager*) self);
#line 2495 "LayoutsManager.c"
}

static void
_keyboard_widgets_layout_manager___lambda14_ (KeyboardWidgetsLayoutManager* self)
{
#line 113 "../src/LayoutsManager.vala"
	keyboard_widgets_layout_manager_set_active_layout_from_settings (self);
#line 114 "../src/LayoutsManager.vala"
	g_signal_emit (self, keyboard_widgets_layout_manager_signals[KEYBOARD_WIDGETS_LAYOUT_MANAGER_UPDATED_SIGNAL], 0);
#line 2505 "LayoutsManager.c"
}

static void
__keyboard_widgets_layout_manager___lambda14__g_settings_changed (GSettings* _sender,
                                                                  const gchar* key,
                                                                  gpointer self)
{
#line 112 "../src/LayoutsManager.vala"
	_keyboard_widgets_layout_manager___lambda14_ ((KeyboardWidgetsLayoutManager*) self);
#line 2515 "LayoutsManager.c"
}

static void
_keyboard_widgets_layout_manager_action_change_layout_g_simple_action_activate (GSimpleAction* _sender,
                                                                                GVariant* parameter,
                                                                                gpointer self)
{
#line 124 "../src/LayoutsManager.vala"
	keyboard_widgets_layout_manager_action_change_layout ((KeyboardWidgetsLayoutManager*) self, _sender, parameter);
#line 2525 "LayoutsManager.c"
}

static GObject *
keyboard_widgets_layout_manager_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	KeyboardWidgetsLayoutManager * self;
	IBusBus* _tmp0_;
	GtkLabel* xkb_header = NULL;
	GtkLabel* _tmp1_ = NULL;
	GtkLabel* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkBox* _tmp4_ = NULL;
	GtkBox* ibus_header_box = NULL;
	GtkBox* _tmp5_;
	GtkSeparator* ibus_separator = NULL;
	GtkSeparator* _tmp6_ = NULL;
	GraniteSwitchModelButton* _tmp7_ = NULL;
	GraniteSwitchModelButton* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkBox* _tmp10_;
	GtkSeparator* _tmp11_;
	GtkBox* _tmp12_;
	GraniteSwitchModelButton* _tmp13_;
	GtkRevealer* _tmp14_;
	GtkRevealer* _tmp15_;
	GtkBox* _tmp16_;
	GtkBox* _tmp17_ = NULL;
	GtkRevealer* _tmp18_;
	GtkRevealer* _tmp19_;
	GtkBox* _tmp20_;
	GraniteSwitchModelButton* _tmp21_;
	GtkLabel* _tmp22_;
	GtkBox* _tmp23_;
	GtkRevealer* _tmp24_;
	GtkRevealer* _tmp25_;
	GSettings* _tmp26_;
	GSettings* _tmp27_;
	IBusBus* _tmp28_;
	IBusBus* _tmp29_;
	GSettings* _tmp30_;
	GSimpleActionGroup* _tmp31_;
	GSimpleAction* action_change_current_layout = NULL;
	GVariantType* _tmp32_;
	GVariantType* _tmp33_;
	GVariant* _tmp34_;
	GVariant* _tmp35_;
	GSimpleAction* _tmp36_;
	GSimpleAction* _tmp37_;
	GSimpleAction* _tmp38_;
	GSimpleActionGroup* _tmp39_;
	GSimpleAction* _tmp40_;
	GSimpleActionGroup* _tmp41_;
#line 44 "../src/LayoutsManager.vala"
	parent_class = G_OBJECT_CLASS (keyboard_widgets_layout_manager_parent_class);
#line 44 "../src/LayoutsManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 44 "../src/LayoutsManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KEYBOARD_WIDGETS_TYPE_LAYOUT_MANAGER, KeyboardWidgetsLayoutManager);
#line 45 "../src/LayoutsManager.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 47 "../src/LayoutsManager.vala"
	ibus_init ();
#line 48 "../src/LayoutsManager.vala"
	_tmp0_ = ibus_bus_new ();
#line 48 "../src/LayoutsManager.vala"
	g_object_ref_sink (_tmp0_);
#line 48 "../src/LayoutsManager.vala"
	_g_object_unref0 (self->priv->bus);
#line 48 "../src/LayoutsManager.vala"
	self->priv->bus = _tmp0_;
#line 50 "../src/LayoutsManager.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new (_ ("Keyboard Layout"));
#line 50 "../src/LayoutsManager.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp1_, GTK_ALIGN_START);
#line 50 "../src/LayoutsManager.vala"
	g_object_ref_sink (_tmp1_);
#line 50 "../src/LayoutsManager.vala"
	xkb_header = _tmp1_;
#line 53 "../src/LayoutsManager.vala"
	_tmp2_ = xkb_header;
#line 53 "../src/LayoutsManager.vala"
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
#line 53 "../src/LayoutsManager.vala"
	gtk_style_context_add_class (_tmp3_, GRANITE_STYLE_CLASS_H4_LABEL);
#line 55 "../src/LayoutsManager.vala"
	_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 55 "../src/LayoutsManager.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp4_, TRUE);
#line 55 "../src/LayoutsManager.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp4_, TRUE);
#line 55 "../src/LayoutsManager.vala"
	g_object_ref_sink (_tmp4_);
#line 55 "../src/LayoutsManager.vala"
	_g_object_unref0 (self->priv->xkb_box);
#line 55 "../src/LayoutsManager.vala"
	self->priv->xkb_box = _tmp4_;
#line 60 "../src/LayoutsManager.vala"
	_tmp5_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 60 "../src/LayoutsManager.vala"
	g_object_ref_sink (_tmp5_);
#line 60 "../src/LayoutsManager.vala"
	ibus_header_box = _tmp5_;
#line 62 "../src/LayoutsManager.vala"
	_tmp6_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 62 "../src/LayoutsManager.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp6_, 3);
#line 62 "../src/LayoutsManager.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp6_, 3);
#line 62 "../src/LayoutsManager.vala"
	g_object_ref_sink (_tmp6_);
#line 62 "../src/LayoutsManager.vala"
	ibus_separator = _tmp6_;
#line 67 "../src/LayoutsManager.vala"
	_tmp7_ = granite_switch_model_button_new (_ ("Input Method"));
#line 67 "../src/LayoutsManager.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp7_, TRUE);
#line 67 "../src/LayoutsManager.vala"
	g_object_ref_sink (_tmp7_);
#line 67 "../src/LayoutsManager.vala"
	_g_object_unref0 (self->priv->ibus_header);
#line 67 "../src/LayoutsManager.vala"
	self->priv->ibus_header = _tmp7_;
#line 70 "../src/LayoutsManager.vala"
	_tmp8_ = self->priv->ibus_header;
#line 70 "../src/LayoutsManager.vala"
	_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) _tmp8_);
#line 70 "../src/LayoutsManager.vala"
	gtk_style_context_add_class (_tmp9_, GRANITE_STYLE_CLASS_H4_LABEL);
#line 72 "../src/LayoutsManager.vala"
	_tmp10_ = ibus_header_box;
#line 72 "../src/LayoutsManager.vala"
	_tmp11_ = ibus_separator;
#line 72 "../src/LayoutsManager.vala"
	gtk_container_add ((GtkContainer*) _tmp10_, (GtkWidget*) _tmp11_);
#line 73 "../src/LayoutsManager.vala"
	_tmp12_ = ibus_header_box;
#line 73 "../src/LayoutsManager.vala"
	_tmp13_ = self->priv->ibus_header;
#line 73 "../src/LayoutsManager.vala"
	gtk_container_add ((GtkContainer*) _tmp12_, (GtkWidget*) _tmp13_);
#line 75 "../src/LayoutsManager.vala"
	_tmp14_ = (GtkRevealer*) gtk_revealer_new ();
#line 75 "../src/LayoutsManager.vala"
	g_object_ref_sink (_tmp14_);
#line 75 "../src/LayoutsManager.vala"
	_g_object_unref0 (self->priv->ibus_header_revealer);
#line 75 "../src/LayoutsManager.vala"
	self->priv->ibus_header_revealer = _tmp14_;
#line 76 "../src/LayoutsManager.vala"
	_tmp15_ = self->priv->ibus_header_revealer;
#line 76 "../src/LayoutsManager.vala"
	_tmp16_ = ibus_header_box;
#line 76 "../src/LayoutsManager.vala"
	gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp16_);
#line 78 "../src/LayoutsManager.vala"
	_tmp17_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 78 "../src/LayoutsManager.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp17_, TRUE);
#line 78 "../src/LayoutsManager.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp17_, TRUE);
#line 78 "../src/LayoutsManager.vala"
	g_object_ref_sink (_tmp17_);
#line 78 "../src/LayoutsManager.vala"
	_g_object_unref0 (self->priv->ibus_box);
#line 78 "../src/LayoutsManager.vala"
	self->priv->ibus_box = _tmp17_;
#line 83 "../src/LayoutsManager.vala"
	_tmp18_ = (GtkRevealer*) gtk_revealer_new ();
#line 83 "../src/LayoutsManager.vala"
	g_object_ref_sink (_tmp18_);
#line 83 "../src/LayoutsManager.vala"
	_g_object_unref0 (self->priv->ibus_box_revealer);
#line 83 "../src/LayoutsManager.vala"
	self->priv->ibus_box_revealer = _tmp18_;
#line 84 "../src/LayoutsManager.vala"
	_tmp19_ = self->priv->ibus_box_revealer;
#line 84 "../src/LayoutsManager.vala"
	_tmp20_ = self->priv->ibus_box;
#line 84 "../src/LayoutsManager.vala"
	gtk_container_add ((GtkContainer*) _tmp19_, (GtkWidget*) _tmp20_);
#line 85 "../src/LayoutsManager.vala"
	_tmp21_ = self->priv->ibus_header;
#line 85 "../src/LayoutsManager.vala"
	g_signal_connect_object ((GtkToggleButton*) _tmp21_, "toggled", (GCallback) __keyboard_widgets_layout_manager___lambda10__gtk_toggle_button_toggled, self, 0);
#line 94 "../src/LayoutsManager.vala"
	_tmp22_ = xkb_header;
#line 94 "../src/LayoutsManager.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp22_);
#line 95 "../src/LayoutsManager.vala"
	_tmp23_ = self->priv->xkb_box;
#line 95 "../src/LayoutsManager.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp23_);
#line 96 "../src/LayoutsManager.vala"
	_tmp24_ = self->priv->ibus_header_revealer;
#line 96 "../src/LayoutsManager.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp24_);
#line 97 "../src/LayoutsManager.vala"
	_tmp25_ = self->priv->ibus_box_revealer;
#line 97 "../src/LayoutsManager.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp25_);
#line 99 "../src/LayoutsManager.vala"
	_tmp26_ = g_settings_new ("org.gnome.desktop.input-sources");
#line 99 "../src/LayoutsManager.vala"
	_g_object_unref0 (self->priv->settings);
#line 99 "../src/LayoutsManager.vala"
	self->priv->settings = _tmp26_;
#line 100 "../src/LayoutsManager.vala"
	_tmp27_ = self->priv->settings;
#line 100 "../src/LayoutsManager.vala"
	g_signal_connect_object (_tmp27_, "changed::sources", (GCallback) __keyboard_widgets_layout_manager___lambda11__g_settings_changed, self, 0);
#line 104 "../src/LayoutsManager.vala"
	_tmp28_ = self->priv->bus;
#line 104 "../src/LayoutsManager.vala"
	g_signal_connect_object (_tmp28_, "connected", (GCallback) __keyboard_widgets_layout_manager___lambda12__ibus_bus_connected, self, 0);
#line 108 "../src/LayoutsManager.vala"
	_tmp29_ = self->priv->bus;
#line 108 "../src/LayoutsManager.vala"
	g_signal_connect_object (_tmp29_, "disconnected", (GCallback) __keyboard_widgets_layout_manager___lambda13__ibus_bus_disconnected, self, 0);
#line 112 "../src/LayoutsManager.vala"
	_tmp30_ = self->priv->settings;
#line 112 "../src/LayoutsManager.vala"
	g_signal_connect_object (_tmp30_, "changed::current", (GCallback) __keyboard_widgets_layout_manager___lambda14__g_settings_changed, self, G_CONNECT_AFTER);
#line 117 "../src/LayoutsManager.vala"
	_tmp31_ = g_simple_action_group_new ();
#line 117 "../src/LayoutsManager.vala"
	_g_object_unref0 (self->priv->actions);
#line 117 "../src/LayoutsManager.vala"
	self->priv->actions = _tmp31_;
#line 118 "../src/LayoutsManager.vala"
	_tmp32_ = g_variant_type_new ("u");
#line 118 "../src/LayoutsManager.vala"
	_tmp33_ = _tmp32_;
#line 118 "../src/LayoutsManager.vala"
	_tmp34_ = g_variant_new_boolean (TRUE);
#line 118 "../src/LayoutsManager.vala"
	g_variant_ref_sink (_tmp34_);
#line 118 "../src/LayoutsManager.vala"
	_tmp35_ = _tmp34_;
#line 118 "../src/LayoutsManager.vala"
	_tmp36_ = g_simple_action_new_stateful ("change-layout", _tmp33_, _tmp35_);
#line 118 "../src/LayoutsManager.vala"
	_tmp37_ = _tmp36_;
#line 118 "../src/LayoutsManager.vala"
	_g_variant_unref0 (_tmp35_);
#line 118 "../src/LayoutsManager.vala"
	_g_variant_type_free0 (_tmp33_);
#line 118 "../src/LayoutsManager.vala"
	action_change_current_layout = _tmp37_;
#line 124 "../src/LayoutsManager.vala"
	_tmp38_ = action_change_current_layout;
#line 124 "../src/LayoutsManager.vala"
	g_signal_connect_object (_tmp38_, "activate", (GCallback) _keyboard_widgets_layout_manager_action_change_layout_g_simple_action_activate, self, 0);
#line 125 "../src/LayoutsManager.vala"
	_tmp39_ = self->priv->actions;
#line 125 "../src/LayoutsManager.vala"
	_tmp40_ = action_change_current_layout;
#line 125 "../src/LayoutsManager.vala"
	g_action_map_add_action ((GActionMap*) _tmp39_, (GAction*) _tmp40_);
#line 126 "../src/LayoutsManager.vala"
	_tmp41_ = self->priv->actions;
#line 126 "../src/LayoutsManager.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "manager", (GActionGroup*) _tmp41_);
#line 128 "../src/LayoutsManager.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 130 "../src/LayoutsManager.vala"
	keyboard_widgets_layout_manager_populate_layouts (self);
#line 44 "../src/LayoutsManager.vala"
	_g_object_unref0 (action_change_current_layout);
#line 44 "../src/LayoutsManager.vala"
	_g_object_unref0 (ibus_separator);
#line 44 "../src/LayoutsManager.vala"
	_g_object_unref0 (ibus_header_box);
#line 44 "../src/LayoutsManager.vala"
	_g_object_unref0 (xkb_header);
#line 44 "../src/LayoutsManager.vala"
	return obj;
#line 2806 "LayoutsManager.c"
}

static void
keyboard_widgets_layout_manager_class_init (KeyboardWidgetsLayoutManagerClass * klass,
                                            gpointer klass_data)
{
#line 19 "../src/LayoutsManager.vala"
	keyboard_widgets_layout_manager_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/LayoutsManager.vala"
	g_type_class_adjust_private_offset (klass, &KeyboardWidgetsLayoutManager_private_offset);
#line 19 "../src/LayoutsManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_keyboard_widgets_layout_manager_get_property;
#line 19 "../src/LayoutsManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_keyboard_widgets_layout_manager_set_property;
#line 19 "../src/LayoutsManager.vala"
	G_OBJECT_CLASS (klass)->constructor = keyboard_widgets_layout_manager_constructor;
#line 19 "../src/LayoutsManager.vala"
	G_OBJECT_CLASS (klass)->finalize = keyboard_widgets_layout_manager_finalize;
#line 19 "../src/LayoutsManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KEYBOARD_WIDGETS_LAYOUT_MANAGER_CURRENT_LANGUAGE_CODE_PROPERTY, keyboard_widgets_layout_manager_properties[KEYBOARD_WIDGETS_LAYOUT_MANAGER_CURRENT_LANGUAGE_CODE_PROPERTY] = g_param_spec_string ("current-language-code", "current-language-code", "current-language-code", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 19 "../src/LayoutsManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), KEYBOARD_WIDGETS_LAYOUT_MANAGER_CURRENT_LAYOUT_VARIANT_PROPERTY, keyboard_widgets_layout_manager_properties[KEYBOARD_WIDGETS_LAYOUT_MANAGER_CURRENT_LAYOUT_VARIANT_PROPERTY] = g_param_spec_string ("current-layout-variant", "current-layout-variant", "current-layout-variant", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 19 "../src/LayoutsManager.vala"
	keyboard_widgets_layout_manager_signals[KEYBOARD_WIDGETS_LAYOUT_MANAGER_UPDATED_SIGNAL] = g_signal_new ("updated", KEYBOARD_WIDGETS_TYPE_LAYOUT_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2831 "LayoutsManager.c"
}

static void
keyboard_widgets_layout_manager_instance_init (KeyboardWidgetsLayoutManager * self,
                                               gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 19 "../src/LayoutsManager.vala"
	self->priv = keyboard_widgets_layout_manager_get_instance_private (self);
#line 24 "../src/LayoutsManager.vala"
	_tmp0_ = g_strdup ("");
#line 24 "../src/LayoutsManager.vala"
	self->priv->_current_language_code = _tmp0_;
#line 25 "../src/LayoutsManager.vala"
	_tmp1_ = g_strdup ("");
#line 25 "../src/LayoutsManager.vala"
	self->priv->_current_layout_variant = _tmp1_;
#line 2850 "LayoutsManager.c"
}

static void
keyboard_widgets_layout_manager_finalize (GObject * obj)
{
	KeyboardWidgetsLayoutManager * self;
#line 19 "../src/LayoutsManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KEYBOARD_WIDGETS_TYPE_LAYOUT_MANAGER, KeyboardWidgetsLayoutManager);
#line 24 "../src/LayoutsManager.vala"
	_g_free0 (self->priv->_current_language_code);
#line 25 "../src/LayoutsManager.vala"
	_g_free0 (self->priv->_current_layout_variant);
#line 29 "../src/LayoutsManager.vala"
	_g_object_unref0 (self->priv->settings);
#line 31 "../src/LayoutsManager.vala"
	(self->priv->engines == NULL) ? NULL : (self->priv->engines = (_g_list_free__g_object_unref0_ (self->priv->engines), NULL));
#line 35 "../src/LayoutsManager.vala"
	_g_object_unref0 (self->priv->xkb_box);
#line 36 "../src/LayoutsManager.vala"
	_g_object_unref0 (self->priv->ibus_box);
#line 37 "../src/LayoutsManager.vala"
	_g_object_unref0 (self->priv->ibus_box_revealer);
#line 38 "../src/LayoutsManager.vala"
	_g_object_unref0 (self->priv->ibus_header_revealer);
#line 39 "../src/LayoutsManager.vala"
	_g_object_unref0 (self->priv->ibus_header);
#line 41 "../src/LayoutsManager.vala"
	_g_object_unref0 (self->priv->bus);
#line 42 "../src/LayoutsManager.vala"
	_g_object_unref0 (self->priv->actions);
#line 19 "../src/LayoutsManager.vala"
	G_OBJECT_CLASS (keyboard_widgets_layout_manager_parent_class)->finalize (obj);
#line 2883 "LayoutsManager.c"
}

static GType
keyboard_widgets_layout_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (KeyboardWidgetsLayoutManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) keyboard_widgets_layout_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KeyboardWidgetsLayoutManager), 0, (GInstanceInitFunc) keyboard_widgets_layout_manager_instance_init, NULL };
	GType keyboard_widgets_layout_manager_type_id;
	keyboard_widgets_layout_manager_type_id = g_type_register_static (gtk_box_get_type (), "KeyboardWidgetsLayoutManager", &g_define_type_info, 0);
	KeyboardWidgetsLayoutManager_private_offset = g_type_add_instance_private (keyboard_widgets_layout_manager_type_id, sizeof (KeyboardWidgetsLayoutManagerPrivate));
	return keyboard_widgets_layout_manager_type_id;
}

GType
keyboard_widgets_layout_manager_get_type (void)
{
	static volatile gsize keyboard_widgets_layout_manager_type_id__once = 0;
	if (g_once_init_enter (&keyboard_widgets_layout_manager_type_id__once)) {
		GType keyboard_widgets_layout_manager_type_id;
		keyboard_widgets_layout_manager_type_id = keyboard_widgets_layout_manager_get_type_once ();
		g_once_init_leave (&keyboard_widgets_layout_manager_type_id__once, keyboard_widgets_layout_manager_type_id);
	}
	return keyboard_widgets_layout_manager_type_id__once;
}

static void
_vala_keyboard_widgets_layout_manager_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec)
{
	KeyboardWidgetsLayoutManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, KEYBOARD_WIDGETS_TYPE_LAYOUT_MANAGER, KeyboardWidgetsLayoutManager);
#line 19 "../src/LayoutsManager.vala"
	switch (property_id) {
#line 19 "../src/LayoutsManager.vala"
		case KEYBOARD_WIDGETS_LAYOUT_MANAGER_CURRENT_LANGUAGE_CODE_PROPERTY:
#line 19 "../src/LayoutsManager.vala"
		g_value_set_string (value, keyboard_widgets_layout_manager_get_current_language_code (self));
#line 19 "../src/LayoutsManager.vala"
		break;
#line 19 "../src/LayoutsManager.vala"
		case KEYBOARD_WIDGETS_LAYOUT_MANAGER_CURRENT_LAYOUT_VARIANT_PROPERTY:
#line 19 "../src/LayoutsManager.vala"
		g_value_set_string (value, keyboard_widgets_layout_manager_get_current_layout_variant (self));
#line 19 "../src/LayoutsManager.vala"
		break;
#line 2930 "LayoutsManager.c"
		default:
#line 19 "../src/LayoutsManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/LayoutsManager.vala"
		break;
#line 2936 "LayoutsManager.c"
	}
}

static void
_vala_keyboard_widgets_layout_manager_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec)
{
	KeyboardWidgetsLayoutManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, KEYBOARD_WIDGETS_TYPE_LAYOUT_MANAGER, KeyboardWidgetsLayoutManager);
#line 19 "../src/LayoutsManager.vala"
	switch (property_id) {
#line 19 "../src/LayoutsManager.vala"
		case KEYBOARD_WIDGETS_LAYOUT_MANAGER_CURRENT_LANGUAGE_CODE_PROPERTY:
#line 19 "../src/LayoutsManager.vala"
		keyboard_widgets_layout_manager_set_current_language_code (self, g_value_get_string (value));
#line 19 "../src/LayoutsManager.vala"
		break;
#line 19 "../src/LayoutsManager.vala"
		case KEYBOARD_WIDGETS_LAYOUT_MANAGER_CURRENT_LAYOUT_VARIANT_PROPERTY:
#line 19 "../src/LayoutsManager.vala"
		keyboard_widgets_layout_manager_set_current_layout_variant (self, g_value_get_string (value));
#line 19 "../src/LayoutsManager.vala"
		break;
#line 2962 "LayoutsManager.c"
		default:
#line 19 "../src/LayoutsManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/LayoutsManager.vala"
		break;
#line 2968 "LayoutsManager.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

